// FIX FOR DECALS CLIPPING
#version 450
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
 
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 30, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   
struct _693
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    float _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    vec3 _m9;
    vec3 _m10;
    float _m11;
    float _m12;
    vec3 _m13;
    vec3 _m14;
    vec4 _m15;
    vec4 _m16;
    mat3 _m17;
    vec3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    vec3 _m26;
    vec3 _m27;
    uvec4 _m28;
    uvec4 _m29;
    uvec4 _m30;
    vec3 _m31;
    vec3 _m32;
    ivec3 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    float _m37;
    uint _m38;
};

struct _968
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

struct _1785
{
    int _m0;
    int _m1;
};

struct _1788
{
    int _m0;
    int _m1;
};

struct _1899
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uvec2 _m3;
    uvec2 _m4;
    uvec2 _m5;
    uint _m6;
    uint _m7;
    uint _m8;
    uint _m9;
    uint _m10;
    uint _m11;
};

struct _2754
{
    vec3 _m0;
    uint _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    uvec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    uint _m11;
    uint _m12;
    float _m13;
    uint _m14;
};

struct _3529
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

struct _4223
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uint _m3;
    uint _m4;
    uint _m5;
    uint _m6;
};

layout(set = 0, binding = 0, std140) uniform _714_716
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
} _716;

layout(set = 2, binding = 0, std140) uniform _817_819
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
} _819;

layout(set = 1, binding = 0, std140) uniform _1679_1681
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
} _1681;

layout(set = 0, binding = 13, std430) restrict readonly buffer _1790_1792
{
    _1788 _m0[];
} _1792;

layout(set = 0, binding = 14, std430) restrict readonly buffer _1874_1876
{
    uint _m0[];
} _1876;

layout(set = 0, binding = 15, std140) uniform _1904_1906
{
    vec4 _m0[4096];
} _1906;

layout(set = 0, binding = 16, std140) uniform _1924_1926
{
    vec4 _m0[4096];
} _1926;

layout(set = 0, binding = 17, std140) uniform _1976_1978
{
    vec4 _m0[4096];
} _1978;

layout(set = 0, binding = 19, std140) uniform _2758_2760
{
    vec4 _m0[4096];
} _2760;

layout(set = 0, binding = 20, std140) uniform _2797_2799
{
    vec4 _m0[4096];
} _2799;

layout(set = 0, binding = 21, std140) uniform _2866_2868
{
    vec4 _m0[3072];
} _2868;

layout(set = 0, binding = 23, std140) uniform _3533_3535
{
    vec4 _m0[4095];
} _3535;

layout(set = 0, binding = 25, std140) uniform _4227_4229
{
    vec4 _m0[4096];
} _4229;

layout(set = 0, binding = 1, std430) restrict readonly buffer _4748_4750
{
    uint _m0[];
} _4750;

layout(set = 0, binding = 2, std430) restrict readonly buffer _4752_4754
{
    vec4 _m0[];
} _4754;

layout(push_constant, std430) uniform _4744_4746
{
    int _m0;
    int _m1;
} _4746;

layout(set = 3, binding = 3) uniform TEXTURE_2D _844[8];
layout(set = 0, binding = 6) uniform sampler _851;
layout(set = 3, binding = 2) uniform TEXTURE_2D _860[8];
layout(set = 0, binding = 7) uniform sampler _864;
layout(set = 3, binding = 0) uniform TEXTURE_2D _873[8];
layout(set = 0, binding = 8) uniform sampler _877;
layout(set = 3, binding = 1) uniform TEXTURE_2D _888[8];
layout(set = 0, binding = 9) uniform sampler _892;
layout(set = 3, binding = 7) uniform TEXTURE_2D _902[8];
layout(set = 0, binding = 10) uniform sampler _906;
layout(set = 3, binding = 4) uniform TEXTURE_2D _915[8];
layout(set = 0, binding = 11) uniform sampler _919;
layout(set = 3, binding = 6) uniform TEXTURE_2D _928[8];
layout(set = 0, binding = 12) uniform sampler _932;
layout(set = 0, binding = 18) uniform SAMPLER_2D _2197;
layout(set = 0, binding = 22) uniform SAMPLER_2D _3092;
layout(set = 0, binding = 24) uniform sampler2DShadow _3855;
layout(set = 0, binding = 26) uniform SAMPLER_2D _4368;
layout(set = 0, binding = 27) uniform SAMPLER_2D _4551;
layout(set = 3, binding = 5) uniform TEXTURE_2D _4743[8];
layout(set = 0, binding = 4) uniform sampler3D _4758;
layout(set = 0, binding = 5) uniform sampler3D _4759;

layout(location = 2) in vec4 _707;
layout(location = 6) in vec4 _721;
layout(location = 3) in vec4 _733;
layout(location = 4) in vec4 _736;
layout(location = 5) in vec4 _739;
layout(location = 10) in vec4 _757;
layout(location = 11) in vec4 _761;
layout(location = 12) in vec4 _765;
layout(location = 14) flat in uvec3 _778;
layout(location = 15) in vec4 _781;
layout(location = 0) out vec4 _4701;
layout(location = 1) out vec4 _4709;
layout(location = 2) out vec4 _4717;

float _262;

uvec4 _32(vec4 _31)
{
    return floatBitsToUint(_31);
}

float _52(float _51)
{
    if (_51 <= 0.040449999272823333740234375)
    {
        return _51 / 12.9200000762939453125;
    }
    else
    {
        return pow((_51 / 1.05499994754791259765625) + 0.0521326996386051177978515625, 2.400000095367431640625);
    }
}

float _64(float _63)
{
    float _316 = _63;
    return _52(_316);
}

float _55(float _54)
{
    return _54 * ((_54 * ((_54 * 0.305306017398834228515625) + 0.6821711063385009765625)) + 0.01252287812530994415283203125);
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

float _133(float _129, vec4 _130, float _131, bool _132)
{
    float _548 = _130.w / (_129 + _130.z);
    return _548 * _131;
}

vec3 _138(vec3 _136, bool _137)
{
    vec3 _561 = (_136 * 2.0) - vec3(1.0);
    float _578 = (1.0 - (_561.x * _561.x)) - (_561.y * _561.y);
    _561.z = sqrt(_10(_578));
    if (_137 == false)
    {
        _561.z = -_561.z;
    }
    return _561;
}

vec3 _145(vec3 _143, mat3 _144)
{
    return normalize(vec3(dot(_143, _144[0]), dot(_143, _144[1]), dot(_143, _144[2])));
}

uint _27(float _26)
{
    return floatBitsToUint(_26);
}

float _43(float _40, float _41, float _42)
{
    return min(_40, min(_41, _42));
}

float _38(float _35, float _36, float _37)
{
    return max(_35, max(_36, _37));
}

vec4 _83(uint _82)
{
    return unpackUnorm4x8(_82).wzyx;
}

vec4 _96(uvec2 _95)
{
    return vec4(float((_95.x >> uint(16)) & 65535u), float(_95.x & 65535u), float((_95.y >> uint(16)) & 65535u), float(_95.y & 65535u)) * 3.0518509447574615478515625e-05;
}

vec4 _108(SAMPLER_2D _104, vec2 _105, vec2 _106, vec2 _107)
{
    return TEXTURE_GRAD(_104, _105, _106, _107);
}

vec4 _86(uint _85)
{
    return vec4(float((_85 >> uint(24)) & 255u), float((_85 >> uint(16)) & 255u), float((_85 >> uint(8)) & 255u), float(_85 & 255u));
}

vec3 _58(vec3 _57)
{
    float _277 = _57.x;
    vec3 _276;
    _276.x = _55(_277);
    float _283 = _57.y;
    _276.y = _55(_283);
    float _289 = _57.z;
    _276.z = _55(_289);
    return _276;
}

vec4 _61(vec4 _60)
{
    vec3 _299 = _60.xyz;
    vec4 _298 = vec4(_58(_299), 1.0);
    float _307 = _60.w;
    _298.w = _55(_307);
    return _298;
}

float _75(float _74)
{
    return (step(0.0, _74) * 2.0) - 1.0;
}

vec4 _22(vec4 _21)
{
    return clamp(_21, vec4(0.0), vec4(1.0));
}

vec3 _90(uint _89)
{
    return vec3(float((_89 >> uint(21)) & 2047u), float((_89 >> uint(10)) & 2047u), float(_89 & 1023u)) / vec3(2047.0, 2047.0, 1023.0);
}

uint _49(float _46, float _47, float _48)
{
    bool _203 = abs(_48) >= abs(_46);
    bool _211;
    if (_203)
    {
        _211 = abs(_48) >= abs(_47);
    }
    else
    {
        _211 = _203;
    }
    if (_211)
    {
        return uint((_48 < 0.0) ? 5 : 4);
    }
    if (abs(_47) >= abs(_46))
    {
        return uint((_47 < 0.0) ? 3 : 2);
    }
    return uint(int(_46 < 0.0));
}

float _67(float _66)
{
    return exp2(_66);
}

vec3 _111(uint _110)
{
    uint _422 = _110;
    vec4 _421 = _83(_422);
    float _433 = (_421.w * 255.0) - 128.0;
    return _421.xyz * _67(_433);
}

float _72(float _70, float _71)
{
    return pow(_70, _71);
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec3 _116(vec3 _114, float _115)
{
    float _445 = 50.0 * dot(_114, vec3(0.33329999446868896484375));
    float _438 = _10(_445);
    float _454 = 1.0 - _115;
    float _457 = _10(_454);
    float _458 = 5.0;
    vec3 _462 = _114 + ((vec3(_438) - _114) * _72(_457, _458));
    return _16(_462);
}

vec3 _124(vec3 _119, vec3 _120, vec3 _121, vec3 _122, float _123)
{
    vec3 _466 = normalize(_120 + _121);
    float _471 = 1.0 - (_123 * 0.800000011920928955078125);
    _471 *= _471;
    _471 *= _471;
    float _482 = _471 * _471;
    float _490 = dot(_119, _466);
    float _486 = _10(_490);
    float _492 = ((_486 * _486) * (_482 - 1.0)) + 1.0;
    _492 = _482 / ((_492 * _492) + 9.9999999392252902907785028219223e-09);
    float _511 = dot(_119, _120);
    float _507 = (_10(_511) * (1.0 - _471)) + _471;
    float _522 = dot(_119, _121);
    float _518 = (_10(_522) * (1.0 - _471)) + _471;
    _492 /= (((4.0 * _507) * _518) + 9.9999999392252902907785028219223e-09);
    vec3 _540 = _122;
    float _542 = dot(_121, _466);
    return _116(_540, _542) * _492;
}

vec2 _149(vec2 _148)
{
    return (vec2(1.0) - abs(_148.yx)) * vec2((_148.x >= 0.0) ? 1.0 : (-1.0), (_148.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _154(inout vec3 _152, bool _153)
{
    _152 /= vec3((abs(_152.x) + abs(_152.y)) + abs(_152.z));
    vec2 _642;
    if (_152.z >= 0.0)
    {
        _642 = _152.xy;
    }
    else
    {
        vec2 _651 = _152.xy;
        _642 = _149(_651);
    }
    _152 = vec3(_642.x, _642.y, _152.z);
    if (_153)
    {
        vec2 _666 = (_152.xy * 0.5) + vec2(0.5);
        _152 = vec3(_666.x, _666.y, _152.z);
    }
    return _152.xy;
}

float _78(float _77)
{
    return sqrt(_77);
}

float _157(float _156)
{
    float _676 = abs(_156);
    float _673 = _78(_676);
    float _678;
    if (_156 > 0.0)
    {
        _678 = _673;
    }
    else
    {
        _678 = -_673;
    }
    return (_678 * 0.5) + 0.5;
}

void main()
{
    _693 _695 = _693(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 1.0, 0u);
    _695._m15 = _707;
    _695._m16 = gl_FragCoord;
    _695._m14 = _716._m2.xyz + _721.xyz;
    _695._m13 = normalize(-_721.xyz);
    _695._m17 = mat3(vec3(_733.xyz), vec3(_736.xyz), vec3(_739.xyz));
    _695._m34 = _757;
    _695._m35 = _761;
    _695._m36 = _765;
    uint _768 = 0u;
    vec4 _769 = vec4(0.0);
    vec4 _770 = vec4(0.0);
    vec4 _771 = vec4(0.0);
    vec4 _772 = vec4(0.0);
    vec4 _773 = vec4(0.0);
    uvec3 _776 = _778;
    vec3 _780 = _781.xyz;
    bool _787 = _776.y == 65535u;
    bool _793;
    if (_787)
    {
        _793 = _776.z == 65535u;
    }
    else
    {
        _793 = _787;
    }
    bool _784 = _793;
    bool _794 = !_784;
    bool _797 = _776.z != 65535u;
    uint _801 = _776.x & 7u;
    uint _812;
    if (_716._m4.x == 0.0)
    {
        _812 = _801;
    }
    else
    {
        vec4 _820 = _819._m3;
        uvec4 _816 = _32(_820);
        uint _824 = _816[_801 / 2u];
        uint _829 = 16u * (_801 & 1u);
        _812 = (_824 >> _829) & 65535u;
    }
    uint _838 = _812;
    float _840 = texture(SAMPLER_2D(_844[_838], _851), _695._m15.zw).x;
    vec2 _859 = texture(SAMPLER_2D(_860[_838], _864), _695._m15.zw).yx;
    vec3 _872 = texture(SAMPLER_2D(_873[_838], _877), _695._m15.zw).xyz;
    vec3 _885 = vec3(0.039999999105930328369140625);
    _885 = texture(SAMPLER_2D(_888[_838], _892), _695._m15.zw).xyz;
    float _900 = 1.0;
    float _901 = texture(SAMPLER_2D(_902[_838], _906), _695._m15.zw).x;
    float _914 = texture(SAMPLER_2D(_915[_838], _919), _695._m15.zw).x;
    vec3 _927 = texture(SAMPLER_2D(_928[_838], _932), _695._m15.zw).xyz;
    _771 = vec4(_872.x, _872.y, _872.z, _771.w);
    _771.w = _859.y;
    _772 = vec4(_885.x, _885.y, _885.z, _772.w);
    _772.w = _914;
    _773 = vec4(_773.x, _859.x, _773.z, _859.y);
    _769.x = _901;
    _769.y = _900;
    _769.z = _914;
    _769.w = _840;
    _770 = vec4(_927.x, _927.y, _927.z, _770.w);
    vec2 _965 = _707.zw;
    _968 _970;
    _970._m0 = _771;
    _970._m1 = _772;
    float _975 = _769.x;
    _970._m2.x = _64(_975);
    _970._m2 = vec4(_970._m2.x, _769.yzw.x, _769.yzw.y, _769.yzw.z);
    _970._m3 = _773;
    _970._m4 = _770;
    _968 _989 = _970;
    vec3 _991 = vec3(0.0);
    bool _999;
    if (_794)
    {
        _999 = _780.x < 65534.0;
    }
    else
    {
        _999 = _794;
    }
    bool _1005;
    if (_999)
    {
        _1005 = _780.x > 0.0;
    }
    else
    {
        _1005 = _999;
    }
    if (_1005)
    {
        uint _1008 = 0u;
        _968 _1009 = _968(vec4(0.0), vec4(0.0), vec4(0.0), vec4(0.0), vec4(0.0));
        uint _1011 = _776.y & 7u;
        uint _1020;
        if (_716._m4.x == 0.0)
        {
            _1020 = _1011;
        }
        else
        {
            vec4 _1024 = _819._m3;
            uvec4 _1023 = _32(_1024);
            uint _1028 = _1023[_1011 / 2u];
            uint _1033 = 16u * (_1011 & 1u);
            _1020 = (_1028 >> _1033) & 65535u;
        }
        uint _1041 = _1020;
        float _1043 = texture(SAMPLER_2D(_844[_1041], _851), _965).x;
        vec2 _1052 = texture(SAMPLER_2D(_860[_1041], _864), _965).yx;
        vec3 _1061 = texture(SAMPLER_2D(_873[_1041], _877), _965).xyz;
        vec3 _1070 = vec3(0.039999999105930328369140625);
        _1070 = texture(SAMPLER_2D(_888[_1041], _892), _965).xyz;
        float _1079 = 1.0;
        float _1080 = texture(SAMPLER_2D(_902[_1041], _906), _965).x;
        float _1089 = texture(SAMPLER_2D(_915[_1041], _919), _965).x;
        vec3 _1098 = texture(SAMPLER_2D(_928[_1041], _932), _965).xyz;
        _1009._m0 = vec4(_1061.x, _1061.y, _1061.z, _1009._m0.w);
        _1009._m0.w = _1052.y;
        _1009._m1 = vec4(_1070.x, _1070.y, _1070.z, _1009._m1.w);
        _1009._m1.w = _1089;
        _1009._m3 = vec4(_1009._m3.x, _1052.x, _1009._m3.z, _1052.y);
        _1009._m2.x = _1080;
        _1009._m2.y = _1079;
        _1009._m2.z = _1089;
        _1009._m2.w = _1043;
        _1009._m4 = vec4(_1098.x, _1098.y, _1098.z, _1009._m4.w);
        float _1136 = _1009._m2.x;
        _1009._m2.x = _55(_1136);
        float _1141 = _1009._m1.w;
        float _1144 = _780.x * _1141;
        float _1149 = _970._m2.x;
        float _1152 = 0.0;
        float _1153 = 0.0;
        float _1154 = (_1144 * 1.5) - 0.5;
        float _1162 = 1.0 - _1149;
        float _1159 = _10(_1162);
        float _1171 = ((_1159 + _1154) - 0.5) * 10.0;
        float _1164 = _10(_1171);
        _1152 = _1164;
        float _1174 = (_780.x * 1.5) - 0.5;
        float _1182 = 1.0 - _1149;
        float _1179 = _10(_1182);
        float _1190 = ((_1179 + _1174) - 0.5) * 10.0;
        float _1184 = _10(_1190);
        _1153 = _1184;
        _989._m0 = mix(_989._m0, _1009._m0, vec4(_1152));
        _989._m1 = mix(_989._m1, _1009._m1, vec4(_1152));
        _989._m2 = mix(_989._m2, _1009._m2, vec4(_1152));
        _989._m3 = mix(_989._m3, _1009._m3, vec4(_1152));
        _989._m4 = mix(_989._m4, _1009._m4, vec4(_1152));
        _768 = (_1152 > 0.5) ? _1008 : _768;
        _991.x = _1152;
    }
    bool _1246;
    if (_797)
    {
        _1246 = _780.y < 65534.0;
    }
    else
    {
        _1246 = _797;
    }
    bool _1252;
    if (_1246)
    {
        _1252 = _780.y > 0.0;
    }
    else
    {
        _1252 = _1246;
    }
    if (_1252)
    {
        uint _1255 = 0u;
        _968 _1256 = _968(vec4(0.0), vec4(0.0), vec4(0.0), vec4(0.0), vec4(0.0));
        uint _1257 = _776.z & 7u;
        uint _1266;
        if (_716._m4.x == 0.0)
        {
            _1266 = _1257;
        }
        else
        {
            vec4 _1270 = _819._m3;
            uvec4 _1269 = _32(_1270);
            uint _1274 = _1269[_1257 / 2u];
            uint _1279 = 16u * (_1257 & 1u);
            _1266 = (_1274 >> _1279) & 65535u;
        }
        uint _1287 = _1266;
        float _1289 = texture(SAMPLER_2D(_844[_1287], _851), _965).x;
        vec2 _1298 = texture(SAMPLER_2D(_860[_1287], _864), _965).yx;
        vec3 _1307 = texture(SAMPLER_2D(_873[_1287], _877), _965).xyz;
        vec3 _1316 = vec3(0.039999999105930328369140625);
        _1316 = texture(SAMPLER_2D(_888[_1287], _892), _965).xyz;
        float _1325 = 1.0;
        float _1326 = texture(SAMPLER_2D(_902[_1287], _906), _965).x;
        float _1335 = texture(SAMPLER_2D(_915[_1287], _919), _965).x;
        vec3 _1344 = texture(SAMPLER_2D(_928[_1287], _932), _965).xyz;
        _1256._m0 = vec4(_1307.x, _1307.y, _1307.z, _1256._m0.w);
        _1256._m0.w = _1298.y;
        _1256._m1 = vec4(_1316.x, _1316.y, _1316.z, _1256._m1.w);
        _1256._m1.w = _1335;
        _1256._m3 = vec4(_1256._m3.x, _1298.x, _1256._m3.z, _1298.y);
        _1256._m2.x = _1326;
        _1256._m2.y = _1325;
        _1256._m2.z = _1335;
        _1256._m2.w = _1289;
        _1256._m4 = vec4(_1344.x, _1344.y, _1344.z, _1256._m4.w);
        float _1382 = _1256._m2.x;
        _1256._m2.x = _55(_1382);
        float _1387 = _1256._m1.w;
        float _1390 = _780.y * _1387;
        float _1395 = _989._m2.x;
        float _1398 = 0.0;
        float _1399 = 0.0;
        float _1400 = (_1390 * 1.5) - 0.5;
        float _1407 = 1.0 - _1395;
        float _1404 = _10(_1407);
        float _1415 = ((_1404 + _1400) - 0.5) * 10.0;
        float _1409 = _10(_1415);
        _1398 = _1409;
        float _1418 = (_780.y * 1.5) - 0.5;
        float _1426 = 1.0 - _1395;
        float _1423 = _10(_1426);
        float _1434 = ((_1423 + _1418) - 0.5) * 10.0;
        float _1428 = _10(_1434);
        _1399 = _1428;
        _989._m0 = mix(_989._m0, _1256._m0, vec4(_1398));
        _989._m1 = mix(_989._m1, _1256._m1, vec4(_1398));
        _989._m2 = mix(_989._m2, _1256._m2, vec4(_1398));
        _989._m3 = mix(_989._m3, _1256._m3, vec4(_1398));
        _989._m4 = mix(_989._m4, _1256._m4, vec4(_1398));
        _768 = (_1398 > 0.5) ? _1255 : _768;
        _991.y = _1398;
    }
    bool _1490;
    if (_794)
    {
        _1490 = _780.z > 0.0;
    }
    else
    {
        _1490 = _794;
    }
    if (_1490)
    {
        float _1493 = _780.z;
        float _1500 = 1.0 - _989._m2.x;
        float _1496 = _10(_1500);
        float _1509 = ((_1496 - 0.5) * _1493) + _1493;
        float _1502 = _10(_1509);
        _991.z = _1502;
        vec3 _1513 = _989._m0.xyz * _989._m0.xyz;
        float _1521 = 1.0 - _989._m2.w;
        float _1533 = (_1502 - 0.0) / 0.3499999940395355224609375;
        vec3 _1538 = mix(_989._m0.xyz, _1513, vec3(_10(_1533) * _1521));
        _989._m0 = vec4(_1538.x, _1538.y, _1538.z, _989._m0.w);
        float _1549 = (_1502 - 0.25) / 0.25;
        vec3 _1552 = mix(_989._m1.xyz, vec3(0.039999999105930328369140625), vec3(_10(_1549)));
        _989._m1 = vec4(_1552.x, _1552.y, _1552.z, _989._m1.w);
        vec3 _1556 = vec3(_695._m17[0].z, _695._m17[1].z, _695._m17[2].z);
        float _1570 = _1556.z + 0.0625;
        float _1564 = _1502 * _10(_1570);
        float _1580 = (_1564 - 0.20000000298023223876953125) / 0.800000011920928955078125;
        _989._m2.w = mix(_989._m2.w, 0.89999997615814208984375, _10(_1580));
        float _1593 = (_1564 - 0.449999988079071044921875) / 0.5299999713897705078125;
        vec3 _1596 = mix(_989._m3.wyz, vec3(0.5, 0.5, 1.0), vec3(_10(_1593)));
        _989._m3 = vec4(_989._m3.x, _1596.y, _1596.z, _1596.x);
        if (_1564 > 0.980000019073486328125)
        {
            float _1610 = (_1564 - 0.980000019073486328125) / 0.0199999995529651641845703125;
            _1556 = normalize(mix(_1556, vec3(0.0, 0.0, 1.0), vec3(_10(_1610))));
            _695._m17[0].z = _1556.x;
            _695._m17[1].z = _1556.y;
            _695._m17[2].z = _1556.z;
        }
    }
    _771 = _989._m0;
    _772 = _989._m1;
    vec3 _1628;
    if (_794)
    {
        _1628 = vec3(0.0);
    }
    else
    {
        _1628 = _769.xyz;
    }
    _769 = vec4(_1628.x, _1628.y, _1628.z, _769.w);
    _769.w = _989._m2.w;
    _773 = _989._m3;
    _770 = _989._m4;
    _695._m10 = vec3(_769.x) * _780;
    _695._m10 *= vec3(_716._m5.x);
    _695._m0 = _771.xyz;
    _695._m2 = _772.xyz;
    _695._m1 = _770.xyz;
    _695._m9 = _769.xyz;
    _695._m3 = _769.w;
    _695._m6 = _773.wyz;
    uint _1678 = uint((_1681._m17.x > 0.0) ? 8 : 0);
    float _1687 = 16.0;
    float _1689 = 8.0;
    float _1691 = 24.0;
    vec2 _1700 = _695._m16.xy * _716._m6.xy;
    vec3 _1693;
    _1693 = vec3(_1700.x, _1700.y, _1693.z);
    _1693.y = 1.0 - _1693.y;
     // FIX FOR DECALS CLIPPING
    //clusterCoordinate.x -= vk3d_params[VIEW].stereo.x * 0.5;
   _1693.x -= vk3d_params[VIEW].stereo.x * 0.5;
    vec2 _1713 = floor(_1693.xy * vec2(_1687, _1689));
    _1693 = vec3(_1713.x, _1713.y, _1693.z);
    float _1718 = _695._m16.z;
    vec4 _1721 = _716._m7;
    float _1724 = 1.0;
    bool _1725 = false;
    float _1716 = _133(_1718, _1721, _1724, _1725);
    float _1727 = log2(max(1.0, _1716 / _716._m8.z)) * _716._m8.w;
    _1693.z = min(_1691 - 1.0, floor(_1727));
    uint _1743 = uint((_1693.x + (_1693.y * _1687)) + ((_1693.z * _1687) * _1689));
    bool _1759 = true;
    vec3 _1761 = _695._m6;
    bool _1764 = _1759;
    _695._m7 = _138(_1761, _1764);
    vec3 _1768 = _695._m7;
    mat3 _1771 = _695._m17;
    _695._m6 = _145(_1768, _1771);
    uint _1776 = 0u;
    uint _1777 = 0u;
    uint _1778 = 0u;
    uint _1779 = 0u;
    uint _1780 = 0u;
    uint _1781 = 0u;
    int _1783 = 256;
    _1785 _1787;
    _1787._m0 = _1792._m0[_1743]._m0;
    _1787._m1 = _1792._m0[_1743]._m1;
    int _1801 = _1787._m0 & (~(_1787._m0 >> 31));
    int _1810 = _1787._m1 & (~(_1787._m1 >> 31));
    _1776 = uint((_1801 >> 16) * _1783);
    _1777 = _1776 + uint(_1810 & 255);
    _1778 = _1776;
    _1779 = _1778 + uint((_1810 >> 8) & 255);
    _1780 = _1776;
    _1781 = _1780 + uint((_1810 >> 16) & 255);
    vec3 _1843 = dFdx(_695._m14);
    vec3 _1847 = dFdy(_695._m14);
    bool _1852 = _1678 == 0u;
    bool _1858;
    if (_1852)
    {
        _1858 = _1681._m17.y == 0.0;
    }
    else
    {
        _1858 = _1852;
    }
    _1778 = _1858 ? _1779 : _1778;
    uint _1862 = _1778;
    _1899 _1901;
    vec3 _2251;
    float _2384;
    while (_1862 < _1779)
    {
        uint _1872 = _1876._m0[_1862];
        uint _1881 = (_1872 >> uint(12)) & 4095u;
        uint _1887 = _1881;
        if (_1887 >= _1881)
        {
            _1862++;
        }
        int _1896 = 2;
        int _1897 = 2;
        int _1898 = 2;
        _1901._m0 = _1906._m0[(uint(_1896) * _1887) + 0u];
        _1901._m1 = _1906._m0[(uint(_1896) * _1887) + 1u];
        _1901._m2 = _1926._m0[(uint(_1897) * _1887) + 0u];
        float _1940 = _1926._m0[(uint(_1897) * _1887) + 1u].x;
        _1901._m3.x = _27(_1940);
        float _1950 = _1926._m0[(uint(_1897) * _1887) + 1u].y;
        _1901._m3.y = _27(_1950);
        float _1960 = _1926._m0[(uint(_1897) * _1887) + 1u].z;
        _1901._m4.x = _27(_1960);
        float _1970 = _1926._m0[(uint(_1897) * _1887) + 1u].w;
        _1901._m4.y = _27(_1970);
        float _1984 = _1978._m0[(uint(_1898) * _1887) + 0u].x;
        _1901._m5.x = _27(_1984);
        float _1994 = _1978._m0[(uint(_1898) * _1887) + 0u].y;
        _1901._m5.y = _27(_1994);
        float _2004 = _1978._m0[(uint(_1898) * _1887) + 0u].z;
        _1901._m6 = _27(_2004);
        float _2014 = _1978._m0[(uint(_1898) * _1887) + 0u].w;
        _1901._m7 = _27(_2014);
        float _2024 = _1978._m0[(uint(_1898) * _1887) + 1u].x;
        _1901._m8 = _27(_2024);
        float _2034 = _1978._m0[(uint(_1898) * _1887) + 1u].y;
        _1901._m9 = _27(_2034);
        float _2044 = _1978._m0[(uint(_1898) * _1887) + 1u].z;
        _1901._m10 = _27(_2044);
        float _2055 = _1978._m0[(uint(_1898) * _1887) + 1u].w;
        _1901._m11 = _27(_2055);
        vec4 _2060 = _1901._m0;
        vec4 _2063 = _1901._m2;
        vec4 _2066 = _1901._m1;
        vec4 _2069 = vec4(_695._m14, 1.0);
        vec3 _2076 = vec3(dot(_2069, _2060), dot(_2069, _2066), dot(_2069, _2063));
        float _2087 = 0.0039215688593685626983642578125;
        float _2089 = _2076.x;
        float _2092 = _2076.y;
        float _2095 = _2076.z;
        bool _2100 = _43(_2089, _2092, _2095) <= _2087;
        bool _2117;
        if (!_2100)
        {
            float _2104 = _2076.x;
            float _2107 = _2076.y;
            float _2110 = _2076.z;
            _2117 = _38(_2104, _2107, _2110) >= (1.0 - _2087);
        }
        else
        {
            _2117 = _2100;
        }
        if (_2117)
        {
            continue;
        }
        uint _2121 = _1901._m11;
        bool _2125 = _1678 != 0u;
        bool _2132;
        if (_2125)
        {
            _2132 = (_2121 & 512u) != 0u;
        }
        else
        {
            _2132 = _2125;
        }
        bool _2145;
        if (!_2132)
        {
            bool _2137 = _1678 == 0u;
            bool _2144;
            if (_2137)
            {
                _2144 = (_2121 & 1024u) != 0u;
            }
            else
            {
                _2144 = _2137;
            }
            _2145 = _2144;
        }
        else
        {
            _2145 = _2132;
        }
        if (_2145)
        {
            continue;
        }
        vec2 _2149 = vec2(dot(_1843, _2060.xyz), dot(_1843, _2066.xyz));
        vec2 _2159 = vec2(dot(_1847, _2060.xyz), dot(_1847, _2066.xyz));
        float _2169 = 1.0;
        float _2170 = 1.0;
        vec3 _2171 = vec3(0.5, 0.5, 1.0);
        vec3 _2172 = vec3(0.0, 0.0, 1.0);
        uint _2173 = _1901._m7;
        uint _2177 = _1901._m9;
        vec4 _2176 = _83(_2177);
        uvec2 _2182 = _1901._m5;
        vec4 _2181 = _96(_2182);
        vec2 _2186 = _2149 * _2181.xy;
        vec2 _2191 = _2159 * _2181.xy;
        vec2 _2206 = (_2076.xy * _2181.xy) + _2181.zw;
        vec2 _2207 = _2186;
        vec2 _2209 = _2191;
        vec4 _2196 = _108(_2197, _2206, _2207, _2209);
        vec2 _2212 = (_2196.xy * 2.0) - vec2(1.0);
        float _2223 = 1.0 - dot(_2212, _2212);
        _2171 = vec3(_2212, sqrt(_10(_2223)));
        _2172 = _2171;
        _2169 = _2196.z;
        float _2232 = _2196.w;
        _2170 = _55(_2232);
        bool _2239 = _2170 <= (4.0 * _2087);
        bool _2246;
        if (_2239)
        {
            _2246 = _2176.w <= _2087;
        }
        else
        {
            _2246 = _2239;
        }
        if (_2246)
        {
            continue;
        }
        _2171 = _2172;
        if ((_2121 & 128u) != 0u)
        {
            _2251 = vec3(-_2171.x, -_2171.y, _2171.z);
        }
        else
        {
            _2251 = _2171;
        }
        _2171 = _2251;
        uint _2270 = _1901._m8;
        uint _2274 = _2270;
        float _2273 = 1.0 + (_86(_2274).w * 0.062745101749897003173828125);
        uint _2282 = _2173;
        float _2281 = _83(_2282).z;
        uint _2287 = _2270;
        vec3 _2286 = _83(_2287).xyz;
        float _2300 = _2273 - (_2273 * abs((_2076.z * 2.0) - 1.0));
        _2170 *= _10(_2300);
        float _2304 = _2170;
        if ((_2173 & 1u) != 0u)
        {
            vec3 _2311 = _2286;
            _2286 = vec3(0.0);
            uvec2 _2314 = _1901._m3;
            vec4 _2313 = _96(_2314);
            vec2 _2318 = _2149 * _2313.xy;
            vec2 _2323 = _2159 * _2313.xy;
            vec2 _2337 = (_2076.xy * _2313.xy) + _2313.zw;
            vec2 _2338 = _2318;
            vec2 _2340 = _2323;
            vec4 _2328 = _108(_2197, _2337, _2338, _2340);
            vec4 _2343 = _2328;
            _2328 = _61(_2343);
            _2286 = _2328.xyz;
            float _2355 = (_2328.w - _2087) / (1.0 - _2087);
            _2304 = _10(_2355);
            _2286 *= _2311;
        }
        vec3 _2360 = normalize(vec3(_695._m17[0].z, _695._m17[1].z, _695._m17[2].z));
        float _2369 = dot(_2360, normalize(_2063.xyz));
        float _2375 = _2369;
        vec2 _2380 = _2171.xy * _75(_2375);
        _2171 = vec3(_2380.x, _2380.y, _2171.z);
        if ((_2121 & 16384u) != 0u)
        {
            float _2393 = abs(_2369);
            _2384 = _10(_2393);
        }
        else
        {
            float _2396 = _2369;
            _2384 = _10(_2396);
        }
        float _2383 = _2384;
        float _2400 = ((_2383 * _2304) * _2176.w) * _2281;
        _695._m10 += (_2176.xyz * (_2400 * 64.0));
        uint _2419 = _1901._m10;
        uint _2423 = _2419;
        vec4 _2422 = _83(_2423);
        if ((_2173 & 2u) != 0u)
        {
            uvec2 _2432 = _1901._m4;
            vec4 _2431 = _96(_2432);
            vec2 _2436 = _2149 * _2431.xy;
            vec2 _2441 = _2159 * _2431.xy;
            vec2 _2454 = (_2076.xy * _2431.xy) + _2431.zw;
            vec2 _2455 = _2436;
            vec2 _2457 = _2441;
            _2422 = _108(_2197, _2454, _2455, _2457);
            _2422 *= _2422;
        }
        if ((_2173 & 32u) != 0u)
        {
            uint _2470 = _2173;
            float _2469 = _83(_2470).x;
            uint _2475 = _2173;
            float _2474 = _86(_2475).y;
            float _2481 = _2469;
            float _2479 = mix(_2474, 0.0, _10(_2481));
            float _2490 = _2169 - (_2479 / 255.0);
            float _2485 = float(_10(_2490) > 0.0);
            _2170 *= _2485;
        }
        float _2497 = _2170 * _2383;
        uint _2501 = _1901._m6;
        uint _2505 = _2501;
        vec4 _2510 = _83(_2505) * _2497;
        vec4 _2504 = _22(_2510);
        _695._m11 = max(_695._m11, _2504.x);
        _695._m0 = mix(_695._m0, _2286, _2504.xxx);
        _695._m2 = mix(_695._m2, _2422.xyz, _2504.yyy);
        vec3 _2533 = _2360;
        vec3 _2543 = _2060.xyz + (_2533 * dot(_2060.xyz, _2533));
        _2060 = vec4(_2543.x, _2543.y, _2543.z, _2060.w);
        vec3 _2554 = _2066.xyz + (_2533 * dot(_2066.xyz, _2533));
        _2066 = vec4(_2554.x, _2554.y, _2554.z, _2066.w);
        _2171 = ((normalize(_2060.xyz) * _2171.x) + (normalize(_2066.xyz) * _2171.y)) + (_2533 * _2171.z);
        if ((_2121 & 256u) != 0u)
        {
            vec3 _2581 = mix(_2360, _2171, _2504.www);
            float _2587 = dot(_2581, _2360);
            _2171 = (_695._m6 * _2587) + ((_2581 - (_2360 * _2587)) * dot(_695._m6, _2360));
        }
        else
        {
            if ((_2121 & 64u) != 0u)
            {
                _2171 = mix(mix(_695._m6, _2360, vec3(_2497)), _2171, _2504.www);
            }
            else
            {
                _2171 = mix(_695._m6, _2171, _2504.www);
            }
        }
        _695._m6 = normalize(_2171);
        _695._m3 = mix(_695._m3, _2422.w, _2504.z);
    }
    vec3 _2641 = vec3(0.0);
    vec3 _2642 = vec3(_695._m34.x, _695._m34.y, _695._m34.z);
    vec3 _2650 = vec3(_695._m34.w, _695._m35.x, _695._m35.y);
    vec3 _2658 = vec3(_695._m35.z, _695._m35.w, _695._m36.x);
    vec3 _2666 = vec3(_695._m36.y, _695._m36.z, _695._m36.w);
    vec3 _2674 = ((_2642 - (_2650 * _695._m6.y)) + (_2658 * _695._m6.z)) - (_2666 * _695._m6.x);
    float _2698 = _1681._m18.x * _716._m9.x;
    _2641 += max(_2674 * _10(_2698), vec3(0.0));
    float _2704;
    if (dot(_695._m10, vec3(1.0)) > 0.0)
    {
        _2704 = -_695._m3;
    }
    else
    {
        _2704 = _695._m3;
    }
    _695._m3 = _2704;
    _695._m18 = _2641;
    _695._m19 = _2641;
    uint _2725 = _1776;
    _2754 _2756;
    vec3 _3050;
    float _3141;
    float _3152;
    _3529 _3531;
    uint _3649;
    _3529 _3675;
    while (_2725 < _1777)
    {
        uint _2735 = _1876._m0[_2725];
        uint _2739 = _2735 & 4095u;
        uint _2742 = _2739;
        if (_2742 >= _2739)
        {
            _2725++;
        }
        int _2751 = 4;
        int _2752 = 4;
        int _2753 = 3;
        _2756._m0 = _2760._m0[(uint(_2751) * _2742) + 0u].xyz;
        float _2775 = _2760._m0[(uint(_2751) * _2742) + 0u].w;
        _2756._m1 = _27(_2775);
        _2756._m2 = _2760._m0[(uint(_2751) * _2742) + 1u];
        _2756._m3 = _2760._m0[(uint(_2751) * _2742) + 2u];
        _2756._m4 = _2799._m0[(uint(_2752) * _2742) + 0u];
        _2756._m5 = _2799._m0[(uint(_2752) * _2742) + 1u];
        _2756._m6 = _2799._m0[(uint(_2752) * _2742) + 2u];
        float _2829 = _2760._m0[(uint(_2751) * _2742) + 3u].x;
        _2756._m7.x = _27(_2829);
        float _2839 = _2760._m0[(uint(_2751) * _2742) + 3u].y;
        _2756._m7.y = _27(_2839);
        float _2849 = _2760._m0[(uint(_2751) * _2742) + 3u].z;
        _2756._m7.z = _27(_2849);
        float _2859 = _2760._m0[(uint(_2751) * _2742) + 3u].w;
        _2756._m7.w = _27(_2859);
        _2756._m8 = _2868._m0[(uint(_2753) * _2742) + 0u];
        _2756._m9 = _2868._m0[(uint(_2753) * _2742) + 1u];
        _2756._m10 = _2868._m0[(uint(_2753) * _2742) + 2u];
        float _2898 = _2799._m0[(uint(_2752) * _2742) + 3u].x;
        _2756._m11 = _27(_2898);
        float _2908 = _2799._m0[(uint(_2752) * _2742) + 3u].y;
        _2756._m12 = _27(_2908);
        _2756._m13 = _2799._m0[(uint(_2752) * _2742) + 3u].z;
        float _2926 = _2799._m0[(uint(_2752) * _2742) + 3u].w;
        _2756._m14 = _27(_2926);
        float _2931 = 0.0039215688593685626983642578125;
        vec4 _2932 = vec4(_695._m14, 1.0);
        float _2939 = 1.0 / dot(_2932, _2756._m6);
        vec3 _2945 = vec3(dot(_2932, _2756._m4) * _2939, dot(_2932, _2756._m5) * _2939, dot(_2932, _2756._m3));
        uint _2963 = _2756._m1;
        uint _2966 = _1678;
        _2966 |= 64u;
        float _2970 = _2945.x;
        float _2973 = _2945.y;
        float _2976 = _2945.z;
        bool _2981 = _43(_2970, _2973, _2976) <= _2931;
        bool _2998;
        if (!_2981)
        {
            float _2985 = _2945.x;
            float _2988 = _2945.y;
            float _2991 = _2945.z;
            _2998 = _38(_2985, _2988, _2991) >= (1.0 - _2931);
        }
        else
        {
            _2998 = _2981;
        }
        bool _3006;
        if (!_2998)
        {
            _3006 = (_2963 & _2966) != 0u;
        }
        else
        {
            _3006 = _2998;
        }
        if (_3006)
        {
            continue;
        }
        if ((_2963 & 3u) == 2u)
        {
            vec2 _3025 = fract((_2945.xy * _716._m10.xy) + _716._m10.zw);
            _2945 = vec3(_3025.x, _3025.y, _2945.z);
        }
        vec3 _3028 = _2756._m0;
        float _3031 = 1.0;
        float _3032 = 1.0;
        vec3 _3033 = vec3(0.0, 0.0, 1.0);
        vec3 _3034 = vec3(0.0, 0.0, 1.0);
        uint _3035 = _2756._m1;
        vec3 _3038 = (_2945 * 2.0) - vec3(1.0);
        vec2 _3043 = _2945.xy;
        vec3 _3046 = _2756._m10.xyz;
        if ((_3035 & 3u) == 2u)
        {
            _3050 = _3046;
        }
        else
        {
            _3050 = normalize(_3028 - _695._m14);
        }
        _3033 = _3050;
        _3033 = _3033;
        float _3070 = dot(_695._m6, _3033);
        float _3065 = _10(_3070);
        bool _3074 = _3065 <= _2931;
        bool _3081;
        if (_3074)
        {
            _3081 = (_3035 & 48u) == 0u;
        }
        else
        {
            _3081 = _3074;
        }
        if (_3081)
        {
            continue;
        }
        uvec2 _3086 = _2756._m7.zw;
        vec4 _3085 = _96(_3086);
        float _3091 = TEXTURE_LOD(_3092, vec4((_3043 * _3085.xy) + _3085.zw, 0.0, 0.0).xy, vec4((_3043 * _3085.xy) + _3085.zw, 0.0, 0.0).w).x;
        float _3118 = _3091 * _3091;
        uint _3122 = _3035 & 3u;
        bool _3127 = _3122 == 1u;
        bool _3139;
        if (!_3127)
        {
            bool _3132 = _3122 == 0u;
            bool _3138;
            if (_3132)
            {
                _3138 = _2756._m8.z != 0.0;
            }
            else
            {
                _3138 = _3132;
            }
            _3139 = _3138;
        }
        else
        {
            _3139 = _3127;
        }
        bool _3125 = _3139;
        if (_3125)
        {
            float _3145 = _2756._m8.w;
            _3141 = _10(_3145);
        }
        else
        {
            _3141 = 0.5;
        }
        float _3140 = _3141;
        bool _3154 = _3122 == 0u;
        bool _3160;
        if (_3154)
        {
            _3160 = _2756._m8.z != 0.0;
        }
        else
        {
            _3160 = _3154;
        }
        if (_3160)
        {
            float _3168 = sqrt(dot(_3038, _3038));
            _3152 = min(0.9921875, _10(_3168));
        }
        else
        {
            _3152 = _2945.z;
        }
        float _3151 = _3152;
        uvec2 _3176 = _2756._m7.xy;
        vec4 _3175 = _96(_3176);
        vec2 _3181 = vec2(_3151, _3140);
        float _3185 = TEXTURE_LOD(_3092, vec4((_3181 * _3175.xy) + _3175.zw, 0.0, 0.0).xy, vec4((_3181 * _3175.xy) + _3175.zw, 0.0, 0.0).w).x;
        _3185 *= _3185;
        _3031 = _3185 * _3118;
        if ((_3035 & 48u) != 0u)
        {
            vec4 _3222 = _2756._m10;
            vec4 _3225 = _2756._m8;
            vec4 _3228 = _2756._m9;
            float _3231 = dot(_695._m14, _3222.xyz) + _3222.w;
            if (_3231 < 0.0)
            {
                continue;
            }
            float _3245 = length(_3222.xyz);
            float _3252 = _3231 * 50.0;
            float _3249 = _10(_3252);
            _3031 *= (_3249 * _3249);
            _3231 /= _3245;
            _3222 /= vec4(_3245);
            vec3 _3266 = reflect(-_695._m13, _695._m6);
            if (dot(_3266, _3222.xyz) > 0.0)
            {
                _3266 = reflect(_3266, _3222.xyz);
            }
            float _3284 = dot(_3266, _3222.xyz);
            float _3289 = _3231 / _3284;
            vec3 _3293 = _695._m14 - (_3266 * _3289);
            vec3 _3300 = _3293 - _3028;
            float _3304 = dot(_3300, _3225.xyz) / _3225.w;
            float _3312 = dot(_3300, _3228.xyz) / _3228.w;
            if ((_3035 & 48u) == 32u)
            {
                vec2 _3325 = vec2(_3304, _3312);
                float _3329 = 1.0 / max(1.0, length(vec2(_3304, _3312)));
                _3304 *= (_3329 * _3225.w);
                _3312 *= (_3329 * _3228.w);
            }
            else
            {
                float _3351 = abs(_3304);
                float _3353 = _3304;
                _3304 = (_10(_3351) * _75(_3353)) * _3225.w;
                float _3362 = abs(_3312);
                float _3364 = _3312;
                _3312 = (_10(_3362) * _75(_3364)) * _3228.w;
            }
            vec3 _3371 = (_3225.xyz * _3304) + (_3228.xyz * _3312);
            _3028 += _3371;
            _3033 = normalize(_3028 - _695._m14);
            _3033 = _3033;
        }
        else
        {
            uint _3391 = (_2756._m14 >> uint(16)) & 255u;
            if (_3391 == 0u)
            {
                vec4 _3400 = _2756._m9;
                if (dot(_3400.xyz, _695._m14) < (_3400.w - _2931))
                {
                    continue;
                }
            }
            else
            {
                if (_3391 == 1u)
                {
                    vec3 _3421 = _2756._m9.xyz;
                    float _3426 = _2756._m9.w;
                    uint _3430 = _27(_3426);
                    vec3 _3425 = (((_90(_3430) * 2.0) - vec3(1.0)) * _3421) + _3028;
                    vec3 _3439 = abs((_695._m14 - _3425) / _3421);
                    float _3447 = _3439.x;
                    float _3450 = _3439.y;
                    float _3453 = _3439.z;
                    if (_38(_3447, _3450, _3453) > 1.0)
                    {
                        continue;
                    }
                }
            }
        }
        if (_3031 <= (_2931 / 256.0))
        {
            continue;
        }
        float _3469 = 1.0;
        if ((_2963 & 4u) != 0u)
        {
            float _3476 = float(_2756._m14 & 255u) / 255.0;
            float _3482 = 0.00999999977648258209228515625;
            vec3 _3484 = _695._m14 + (_695._m6 * _3482);
            uint _3492 = 0u;
            if ((_2963 & 3u) == 0u)
            {
                vec3 _3498 = _3484 - _2756._m2.xyz;
                float _3504 = _3498.x;
                float _3507 = _3498.y;
                float _3510 = _3498.z;
                _3492 = _49(_3504, _3507, _3510);
            }
            else
            {
                if ((_2963 & 3u) == 2u)
                {
                    float _3520 = 0.0;
                    for (; _3492 < 3u; _3492++)
                    {
                        int _3528 = 5;
                        _3531._m0 = _3535._m0[(uint(_3528) * ((_2963 >> uint(22)) + _3492)) + 0u];
                        _3531._m1 = _3535._m0[(uint(_3528) * ((_2963 >> uint(22)) + _3492)) + 1u];
                        _3531._m2 = _3535._m0[(uint(_3528) * ((_2963 >> uint(22)) + _3492)) + 2u];
                        _3531._m3 = _3535._m0[(uint(_3528) * ((_2963 >> uint(22)) + _3492)) + 3u];
                        _3531._m4 = _3535._m0[(uint(_3528) * ((_2963 >> uint(22)) + _3492)) + 4u];
                        vec2 _3592 = vec2(dot(_3484, _3531._m0.xyz) + _3531._m0.w, dot(_3484, _3531._m1.xyz) + _3531._m1.w);
                        _3592 = abs((_3592 * 2.0) - vec2(1.0));
                        bool _3617 = _3592.x < 1.0;
                        bool _3623;
                        if (_3617)
                        {
                            _3623 = _3592.y < 1.0;
                        }
                        else
                        {
                            _3623 = _3617;
                        }
                        if (_3623)
                        {
                            _3520 = (1.0 - max(_3592.x, _3592.y)) * _716._m11.w;
                            break;
                        }
                    }
                    _3492 = min(2u, _3492);
                    uint _3640 = uint(_695._m16.x) ^ (uint(_695._m16.y) << uint(1));
                    if (_716._m12.w > 0.0)
                    {
                        _3649 = uint(_716._m13.x);
                    }
                    else
                    {
                        _3649 = 0u;
                    }
                    _3640 ^= _3649;
                    _3492 += uint(int(((float(_3640 & 3u) * 0.25) + 0.125) > _3520));
                }
            }
            int _3674 = 5;
            _3675._m0 = _3535._m0[(uint(_3674) * ((_2963 >> uint(22)) + _3492)) + 0u];
            _3675._m1 = _3535._m0[(uint(_3674) * ((_2963 >> uint(22)) + _3492)) + 1u];
            _3675._m2 = _3535._m0[(uint(_3674) * ((_2963 >> uint(22)) + _3492)) + 2u];
            _3675._m3 = _3535._m0[(uint(_3674) * ((_2963 >> uint(22)) + _3492)) + 3u];
            _3675._m4 = _3535._m0[(uint(_3674) * ((_2963 >> uint(22)) + _3492)) + 4u];
            vec4 _3731 = vec4((_3484.x * _3675._m0.x) + ((_3484.y * _3675._m0.y) + ((_3484.z * _3675._m0.z) + _3675._m0.w)), (_3484.x * _3675._m1.x) + ((_3484.y * _3675._m1.y) + ((_3484.z * _3675._m1.z) + _3675._m1.w)), (_3484.x * _3675._m2.x) + ((_3484.y * _3675._m2.y) + ((_3484.z * _3675._m2.z) + _3675._m2.w)), (_3484.x * _3675._m3.x) + ((_3484.y * _3675._m3.y) + ((_3484.z * _3675._m3.z) + _3675._m3.w)));
            vec3 _3818 = _3731.xyz / vec3(_3731.w);
            _3731 = vec4(_3818.x, _3818.y, _3818.z, _3731.w);
            bool _3826 = min(_3731.x, _3731.y) > 0.0;
            bool _3835;
            if (_3826)
            {
                _3835 = max(_3731.x, _3731.y) < 1.0;
            }
            else
            {
                _3835 = _3826;
            }
            if (_3835)
            {
                vec2 _3847 = (_3731.xy * _3675._m4.xy) + _3675._m4.zw;
                _3731 = vec4(_3847.x, _3847.y, _3731.z, _3731.w);
                if (false)
                {
                    _3469 = textureLod(_3855, vec3(_3731.xyz.xy, _3731.xyz.z), 0.0);
                }
                else
                {
                    vec2 _3862 = (_3731.xy * _716._m14.xy) + vec2(0.5);
                    vec2 _3871 = floor(_3862);
                    vec2 _3874 = _3862 - _3871;
                    _3871 -= vec2(0.5);
                    vec2 _3881 = vec2(4.0) - (_3874 * 3.0);
                    vec2 _3887 = vec2(7.0);
                    vec2 _3890 = vec2(1.0) + (_3874 * 3.0);
                    vec2 _3895 = (_3871 + (((vec2(3.0) - (_3874 * 2.0)) / _3881) - vec2(2.0))) * _716._m14.zw;
                    vec2 _3910 = (_3871 + ((vec2(3.0) + _3874) / _3887)) * _716._m14.zw;
                    vec2 _3922 = (_3871 + ((_3874 / _3890) + vec2(2.0))) * _716._m14.zw;
                    vec3 _3946 = vec3(_3895.x, _3895.y, _3731.z);
                    _3469 = (_3881.x * _3881.y) * textureLod(_3855, vec3(_3946.xy, _3946.z), 0.0);
                    vec3 _3962 = vec3(_3910.x, _3895.y, _3731.z);
                    _3469 += ((_3887.x * _3881.y) * textureLod(_3855, vec3(_3962.xy, _3962.z), 0.0));
                    vec3 _3980 = vec3(_3922.x, _3895.y, _3731.z);
                    _3469 += ((_3890.x * _3881.y) * textureLod(_3855, vec3(_3980.xy, _3980.z), 0.0));
                    vec3 _3998 = vec3(_3895.x, _3910.y, _3731.z);
                    _3469 += ((_3881.x * _3887.y) * textureLod(_3855, vec3(_3998.xy, _3998.z), 0.0));
                    vec3 _4016 = vec3(_3910.x, _3910.y, _3731.z);
                    _3469 += ((_3887.x * _3887.y) * textureLod(_3855, vec3(_4016.xy, _4016.z), 0.0));
                    vec3 _4034 = vec3(_3922.x, _3910.y, _3731.z);
                    _3469 += ((_3890.x * _3887.y) * textureLod(_3855, vec3(_4034.xy, _4034.z), 0.0));
                    vec3 _4052 = vec3(_3895.x, _3922.y, _3731.z);
                    _3469 += ((_3881.x * _3890.y) * textureLod(_3855, vec3(_4052.xy, _4052.z), 0.0));
                    vec3 _4070 = vec3(_3910.x, _3922.y, _3731.z);
                    _3469 += ((_3887.x * _3890.y) * textureLod(_3855, vec3(_4070.xy, _4070.z), 0.0));
                    vec3 _4088 = vec3(_3922.x, _3922.y, _3731.z);
                    _3469 += ((_3890.x * _3890.y) * textureLod(_3855, vec3(_4088.xy, _4088.z), 0.0));
                    _3469 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _3469 = float((_2963 & 3u) == 2u);
            }
            float _4102 = float((_2963 >> uint(16)) & 63u) / 63.0;
            float _4116 = ((_3469 * _4102) + 1.0) - _4102;
            _3469 = _10(_4116);
        }
        uint _4119 = _2756._m12;
        vec3 _4118 = (_111(_4119) * _3469) * _3031;
        _3032 *= _2756._m13;
        vec3 _4131 = _4118;
        vec3 _4133 = _3033;
        float _4140 = dot(_695._m6, _4133);
        float _4135 = _10(_4140);
        vec3 _4146 = _695._m6;
        vec3 _4149 = _695._m13;
        vec3 _4152 = _3033;
        vec3 _4154 = _695._m2;
        float _4157 = abs(_695._m3);
        vec3 _4142 = _124(_4146, _4149, _4152, _4154, _4157);
        _695._m20 += (((_4142 * _3032) * _4131) * _4135);
        vec3 _4171 = mix(_4131, vec3(0.0), bvec3((_2963 & 256u) > 0u));
        _695._m19 += (_4171 * _4135);
    }
    _695._m19 = _695._m19;
    _695._m20 += _695._m10;
    float _4195 = 0.064999997615814208984375;
    float _4197 = 1.0 + _4195;
    bool _4200 = false;
    uint _4202;
    if (_716._m15.w > 0.00999999977648258209228515625)
    {
        _4202 = uint(_716._m15.x);
    }
    else
    {
        _4202 = 0u;
    }
    uint _4201 = _4202;
    _4223 _4225;
    for (uint _4213 = 0u; _4213 < _4201; _4213++)
    {
        int _4222 = 4;
        _4225._m0 = _4229._m0[(uint(_4222) * _4213) + 0u];
        _4225._m1 = _4229._m0[(uint(_4222) * _4213) + 1u];
        _4225._m2 = _4229._m0[(uint(_4222) * _4213) + 2u];
        float _4259 = _4229._m0[(uint(_4222) * _4213) + 3u].x;
        _4225._m3 = _27(_4259);
        float _4269 = _4229._m0[(uint(_4222) * _4213) + 3u].y;
        _4225._m4 = _27(_4269);
        float _4279 = _4229._m0[(uint(_4222) * _4213) + 3u].z;
        _4225._m5 = _27(_4279);
        vec4 _4284 = vec4(_695._m14, 1.0);
        vec3 _4291 = vec3(dot(_4284, _4225._m1), dot(_4284, _4225._m2), dot(_4284, _4225._m0));
        float _4305 = _4291.x;
        float _4308 = _4291.y;
        float _4311 = _4291.z;
        bool _4315 = _43(_4305, _4308, _4311) >= 0.0;
        bool _4324;
        if (_4315)
        {
            _4324 = max(_4291.x, _4291.y) < 1.0;
        }
        else
        {
            _4324 = _4315;
        }
        bool _4331;
        if (_4324)
        {
            _4331 = _4291.z < _4197;
        }
        else
        {
            _4331 = _4324;
        }
        if (_4331)
        {
            float _4334 = _4291.z;
            vec4 _4337 = vec4(_695._m14, 1.0);
            vec2 _4344 = vec2(0.0);
            _4344 = (((_4337.xy - _716._m16.zw) / vec2(16.0)) * 0.5) + vec2(0.5);
            float _4357 = 0.000244140625;
            float _4363 = abs(_695._m6.z) * 2.0;
            _4357 *= _10(_4363);
            vec3 _4367 = vec3(TEXTURE_LOD(_4368, vec4(_4344 + vec2(_4357), 0.0, 0.0).xy, vec4(_4344 + vec2(_4357), 0.0, 0.0).w).x, TEXTURE_LOD(_4368, vec4(_4344, 0.0, 0.0).xy, vec4(_4344, 0.0, 0.0).w).x, TEXTURE_LOD(_4368, vec4(_4344 - vec2(_4357), 0.0, 0.0).xy, vec4(_4344 - vec2(_4357), 0.0, 0.0).w).x);
            float _4431 = 2.0 - (2.0 * (length(_4337.xy - _716._m16.zw) / 16.0));
            _4367 *= _10(_4431);
            float _4438 = 1.0 - _4334;
            float _4435 = smoothstep(0.0, 0.00999999977648258209228515625, _10(_4438));
            float _4449 = (_695._m6.z * 0.800000011920928955078125) + 0.20000000298023223876953125;
            vec3 _4441 = (_4367 * _4435) * _10(_4449);
            float _4458 = _4197 - _4334;
            float _4452 = (1.0 - _4435) * smoothstep(0.0, 0.00999999977648258209228515625, _10(_4458));
            float _4472 = ((-_695._m6.z) * 0.89999997615814208984375) + 0.100000001490116119384765625;
            vec3 _4462 = (_4367 * _4452) * _10(_4472);
            _4367 = _4441 + _4462;
            float _4483 = 1.02499997615814208984375 - _4334;
            float _4478 = smoothstep(0.0, 0.02999999932944774627685546875, _10(_4483));
            float _4486 = _716._m15.w;
            _695._m19 = mix(_695._m19, (_695._m19 * _4367) + (_695._m19 * mix(1.0, 0.5, _4478)), vec3(_4486));
            break;
        }
    }
    _695._m19 *= _695._m0;
    _695._m21 = _695._m19 + _695._m20;
    vec3 _4520 = vec3(0.0);
    if (_1681._m19.w > 0.0)
    {
        vec4 _4526 = vec4(0.0030000000260770320892333984375, 0.00999999977648258209228515625, 0.0500000007450580596923828125, 0.300000011920928955078125);
        vec2 _4531 = abs(vec2(1.0) / _716._m6.zw);
        vec2 _4537 = ((gl_FragCoord.xy * 1.5) * _716._m6.zw) * (_4531 / vec2(32.0));
        vec4 _4550 = TEXTURE_LOD(_4551, vec4((_4537 * _4526.xy) + (vec2(_716._m1.x * 0.75) * _4526.zw), 0.0, 0.0).xy, vec4((_4537 * _4526.xy) + (vec2(_716._m1.x * 0.75) * _4526.zw), 0.0, 0.0).w);
        float _4593 = (length(_721.xyz) - 10.0) * 2.0;
        float _4587 = 1.0 - _10(_4593);
        float _4596 = 1.0 - dot(_695._m6, normalize(-_721.xyz));
        float _4605 = 2.0;
        _4605 *= ((sin((_716._m1.x * 5.0) * 0.75) * 0.5) + 0.699999988079071044921875);
        _4605 *= _4605;
        _4605 *= _4596;
        _4596 *= _4596;
        float _4625 = (_4596 * _4596) * 9.9999997473787516355514526367188e-05;
        vec3 _4635 = _4550.xyz * _4550.xyz;
        _4550 = vec4(_4635.x, _4635.y, _4635.z, _4550.w);
        vec3 _4638 = _4550.xyz;
        float _4648 = (_4638.x * _4596) + _4625;
        vec3 _4641 = _1681._m19.xyz * _10(_4648);
        float _4655 = _4638.x;
        vec3 _4654 = _1681._m19.xyz * _10(_4655);
        vec3 _4663 = mix(_4641, _4654, vec3(0.0500000007450580596923828125));
        float _4673 = (0.5 * _4596) + _4625;
        vec3 _4668 = _1681._m19.xyz * _10(_4673);
        _4663 /= _716._m17.xyz;
        vec3 _4684 = (_4663 * _1681._m19.w) * 0.5;
        _4520 += (_4684 * _4587);
    }
    _695._m19 += _4520;
    vec3 _4706 = _695._m19 + _695._m20;
    _4701 = vec4(_4706.x, _4706.y, _4706.z, _4701.w);
    vec3 _4710 = _695._m6;
    bool _4713 = false;
    vec2 _4714 = _154(_4710, _4713);
    _4709 = vec4(_4714.x, _4714.y, _4709.z, _4709.w);
    float _4718 = _695._m2.x;
    float _4722 = _695._m2.y;
    float _4726 = _695._m2.z;
    float _4730 = _695._m3;
    _4717 = vec4(_78(_4718), _78(_4722), _78(_4726), _157(_4730));
    vec3 _4740 = _4701.xyz + _1681._m2.xyz;
    _4701 = vec4(_4740.x, _4740.y, _4740.z, _4701.w);
}

