#version 450
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_NV_shading_rate_image : require

struct _703
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    float _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    vec3 _m9;
    vec3 _m10;
    float _m11;
    float _m12;
    vec3 _m13;
    vec3 _m14;
    vec4 _m15;
    vec4 _m16;
    mat3 _m17;
    vec3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    vec3 _m26;
    vec3 _m27;
    uvec4 _m28;
    uvec4 _m29;
    uvec4 _m30;
    vec3 _m31;
    vec3 _m32;
    ivec3 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    float _m37;
    uint _m38;
};

struct _1474
{
    int _m0;
    int _m1;
};

struct _1477
{
    int _m0;
    int _m1;
};

struct _1722
{
    vec3 _m0;
    uint _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    uvec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    uint _m11;
    uint _m12;
    float _m13;
    uint _m14;
};

struct _3060
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

struct _3824
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uint _m3;
    uint _m4;
    uint _m5;
    uint _m6;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 30, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 0, binding = 0, std140) uniform _724_726
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
} _726;

layout(set = 2, binding = 0, std140) uniform _827_829
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
} _829;

layout(set = 1, binding = 0, std140) uniform _1278_1280
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
    vec4 _m26;
    vec4 _m27;
    vec4 _m28;
    vec4 _m29;
} _1280;

layout(set = 0, binding = 13, std430) restrict readonly buffer _1479_1481
{
    _1477 _m0[];
} _1481;

layout(set = 0, binding = 14, std430) restrict readonly buffer _1698_1700
{
    uint _m0[];
} _1700;

layout(set = 0, binding = 15, std140) uniform _1727_1729
{
    vec4 _m0[4096];
} _1729;

layout(set = 0, binding = 16, std140) uniform _1766_1768
{
    vec4 _m0[4096];
} _1768;

layout(set = 0, binding = 17, std140) uniform _1835_1837
{
    vec4 _m0[3072];
} _1837;

layout(set = 0, binding = 20, std140) uniform _3064_3066
{
    vec4 _m0[4095];
} _3066;

layout(set = 0, binding = 22, std140) uniform _3828_3830
{
    vec4 _m0[4096];
} _3830;

layout(set = 0, binding = 1, std430) restrict readonly buffer _4227_4229
{
    vec4 _m0[];
} _4229;

layout(push_constant, std430) uniform _4223_4225
{
    int _m0;
    int _m1;
} _4225;

layout(set = 3, binding = 3) uniform TEXTURE_2D _855[8];
layout(set = 0, binding = 5) uniform sampler _862;
layout(set = 3, binding = 2) uniform TEXTURE_2D _907[8];
layout(set = 0, binding = 6) uniform sampler _911;
layout(set = 3, binding = 0) uniform TEXTURE_2D _922[8];
layout(set = 0, binding = 7) uniform sampler _926;
layout(set = 3, binding = 1) uniform TEXTURE_2D _937[8];
layout(set = 0, binding = 8) uniform sampler _941;
layout(set = 3, binding = 5) uniform TEXTURE_2D _950[8];
layout(set = 0, binding = 9) uniform sampler _954;
layout(set = 3, binding = 7) uniform TEXTURE_2D _963[8];
layout(set = 0, binding = 10) uniform sampler _967;
layout(set = 3, binding = 4) uniform TEXTURE_2D _976[8];
layout(set = 0, binding = 11) uniform sampler _980;
layout(set = 3, binding = 6) uniform TEXTURE_2D _989[8];
layout(set = 0, binding = 12) uniform sampler _993;
layout(set = 1, binding = 1) uniform SAMPLER_2D _1288;
layout(set = 1, binding = 2) uniform SAMPLER_2D _1293;
layout(set = 0, binding = 18) uniform samplerCubeArray _2235;
layout(set = 0, binding = 19) uniform SAMPLER_2D _2621;
layout(set = 0, binding = 21) uniform sampler2DShadow _3386;
layout(set = 0, binding = 23) uniform SAMPLER_2D _3969;
layout(set = 0, binding = 24) uniform SAMPLER_2D _4134;
layout(set = 0, binding = 3) uniform sampler3D _4233;
layout(set = 0, binding = 4) uniform sampler3D _4234;

layout(location = 2) in vec4 _717;
layout(location = 6) in vec4 _731;
layout(location = 3) in vec4 _743;
layout(location = 4) in vec4 _746;
layout(location = 5) in vec4 _749;
layout(location = 10) in vec4 _767;
layout(location = 11) in vec4 _771;
layout(location = 12) in vec4 _775;
layout(location = 14) flat in uvec3 _788;
layout(location = 15) in vec4 _791;
layout(location = 8) in vec4 _1298;
layout(location = 0) out vec4 _4180;
layout(location = 1) out vec4 _4188;
layout(location = 2) out vec4 _4196;

float _248;

uvec4 _28(vec4 _27)
{
    return floatBitsToUint(_27);
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

float _48(float _47)
{
    if (_47 <= 0.040449999272823333740234375)
    {
        return _47 / 12.9200000762939453125;
    }
    else
    {
        return pow((_47 / 1.05499994754791259765625) + 0.0521326996386051177978515625, 2.400000095367431640625);
    }
}

vec3 _51(vec3 _50)
{
    float _250 = _50.x;
    vec3 _249;
    _249.x = _48(_250);
    float _256 = _50.y;
    _249.y = _48(_256);
    float _262 = _50.z;
    _249.z = _48(_262);
    return _249;
}

vec3 _54(vec3 _53)
{
    vec3 _271 = _53;
    return _51(_271);
}

float _117(float _113, vec4 _114, float _115, bool _116)
{
    float _545 = _114.w / (_113 + _114.z);
    return _545 * _115;
}

vec3 _122(vec3 _120, bool _121)
{
    vec3 _558 = (_120 * 2.0) - vec3(1.0);
    float _575 = (1.0 - (_558.x * _558.x)) - (_558.y * _558.y);
    _558.z = sqrt(_10(_575));
    if (_121 == false)
    {
        _558.z = -_558.z;
    }
    return _558;
}

vec3 _129(vec3 _127, mat3 _128)
{
    return normalize(vec3(dot(_127, _128[0]), dot(_127, _128[1]), dot(_127, _128[2])));
}

vec3 _135(vec3 _132, mat3 _133, bool _134)
{
    vec3 _608 = _132;
    bool _610 = _134;
    vec3 _607 = _122(_608, _610);
    vec3 _613 = _607;
    mat3 _615 = _133;
    return _129(_613, _615);
}

uint _21(float _20)
{
    return floatBitsToUint(_20);
}

float _39(float _36, float _37, float _38)
{
    return min(_36, min(_37, _38));
}

float _34(float _31, float _32, float _33)
{
    return max(_31, max(_32, _33));
}

vec4 _73(uint _72)
{
    return unpackUnorm4x8(_72).wzyx;
}

float _57(float _56)
{
    return exp2(_56);
}

vec3 _89(uint _88)
{
    uint _370 = _88;
    vec4 _369 = _73(_370);
    float _382 = (_369.w * 255.0) - 128.0;
    return _369.xyz * _57(_382);
}

vec4 _76(uint _75)
{
    return vec4(float((_75 >> uint(24)) & 255u), float((_75 >> uint(16)) & 255u), float((_75 >> uint(8)) & 255u), float(_75 & 255u));
}

vec3 _108(float _105, float _106, vec3 _107)
{
    float _497 = 0.0949999988079071044921875 + (_106 * (0.60000002384185791015625 + (4.190000057220458984375 * _106)));
    float _507 = _105 + 0.02500000037252902984619140625;
    float _511 = (9.5 * _106) * _105;
    float _525 = 1.0 - (14.0 * _105);
    float _517 = (_497 * _507) * _57(_525);
    float _532 = -_511;
    float _528 = 0.4000000059604644775390625 + (0.60000002384185791015625 * (1.0 - _57(_532)));
    return mix(vec3(_517), vec3(_528), _107);
}

vec4 _86(uvec2 _85)
{
    return vec4(float((_85.x >> uint(16)) & 65535u), float(_85.x & 65535u), float((_85.y >> uint(16)) & 65535u), float(_85.y & 65535u)) * 3.0518509447574615478515625e-05;
}

float _65(float _64)
{
    return (step(0.0, _64) * 2.0) - 1.0;
}

vec3 _80(uint _79)
{
    return vec3(float((_79 >> uint(21)) & 2047u), float((_79 >> uint(10)) & 2047u), float(_79 & 1023u)) / vec3(2047.0, 2047.0, 1023.0);
}

uint _45(float _42, float _43, float _44)
{
    bool _189 = abs(_44) >= abs(_42);
    bool _197;
    if (_189)
    {
        _197 = abs(_44) >= abs(_43);
    }
    else
    {
        _197 = _189;
    }
    if (_197)
    {
        return uint((_44 < 0.0) ? 5 : 4);
    }
    if (abs(_43) >= abs(_42))
    {
        return uint((_43 < 0.0) ? 3 : 2);
    }
    return uint(int(_42 < 0.0));
}

float _62(float _60, float _61)
{
    return pow(_60, _61);
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec3 _94(vec3 _92, float _93)
{
    float _394 = 50.0 * dot(_92, vec3(0.33329999446868896484375));
    float _387 = _10(_394);
    float _403 = 1.0 - _93;
    float _406 = _10(_403);
    float _407 = 5.0;
    vec3 _411 = _92 + ((vec3(_387) - _92) * _62(_406, _407));
    return _16(_411);
}

vec3 _102(vec3 _97, vec3 _98, vec3 _99, vec3 _100, float _101)
{
    vec3 _415 = normalize(_98 + _99);
    float _420 = 1.0 - (_101 * 0.800000011920928955078125);
    _420 *= _420;
    _420 *= _420;
    float _431 = _420 * _420;
    float _439 = dot(_97, _415);
    float _435 = _10(_439);
    float _441 = ((_435 * _435) * (_431 - 1.0)) + 1.0;
    _441 = _431 / ((_441 * _441) + 9.9999999392252902907785028219223e-09);
    float _460 = dot(_97, _98);
    float _456 = (_10(_460) * (1.0 - _420)) + _420;
    float _471 = dot(_97, _99);
    float _467 = (_10(_471) * (1.0 - _420)) + _420;
    _441 /= (((4.0 * _456) * _467) + 9.9999999392252902907785028219223e-09);
    vec3 _489 = _100;
    float _491 = dot(_99, _415);
    return _94(_489, _491) * _441;
}

vec2 _141(vec2 _140)
{
    return (vec2(1.0) - abs(_140.yx)) * vec2((_140.x >= 0.0) ? 1.0 : (-1.0), (_140.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _146(inout vec3 _144, bool _145)
{
    _144 /= vec3((abs(_144.x) + abs(_144.y)) + abs(_144.z));
    vec2 _655;
    if (_144.z >= 0.0)
    {
        _655 = _144.xy;
    }
    else
    {
        vec2 _661 = _144.xy;
        _655 = _141(_661);
    }
    _144 = vec3(_655.x, _655.y, _144.z);
    if (_145)
    {
        vec2 _676 = (_144.xy * 0.5) + vec2(0.5);
        _144 = vec3(_676.x, _676.y, _144.z);
    }
    return _144.xy;
}

float _68(float _67)
{
    return sqrt(_67);
}

float _149(float _148)
{
    float _686 = abs(_148);
    float _683 = _68(_686);
    float _690;
    if (_148 > 0.0)
    {
        _690 = _683;
    }
    else
    {
        _690 = -_683;
    }
    return (_690 * 0.5) + 0.5;
}

void main()
{
    _703 _705 = _703(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 1.0, 0u);
    _705._m15 = _717;
    _705._m16 = gl_FragCoord;
    _705._m14 = _726._m0.xyz + _731.xyz;
    _705._m13 = normalize(-_731.xyz);
    _705._m17 = mat3(vec3(_743.xyz), vec3(_746.xyz), vec3(_749.xyz));
    _705._m34 = _767;
    _705._m35 = _771;
    _705._m36 = _775;
    uint _778 = 0u;
    vec4 _779 = vec4(0.0);
    vec4 _780 = vec4(0.0);
    vec4 _781 = vec4(0.0);
    vec4 _782 = vec4(0.0);
    vec4 _783 = vec4(0.0);
    uvec3 _786 = _788;
    vec3 _790 = _791.xyz;
    bool _797 = _786.y == 65535u;
    bool _803;
    if (_797)
    {
        _803 = _786.z == 65535u;
    }
    else
    {
        _803 = _797;
    }
    bool _794 = _803;
    bool _804 = !_794;
    bool _807 = _786.z != 65535u;
    uint _811 = _786.x & 7u;
    uint _822;
    if (_726._m2.x == 0.0)
    {
        _822 = _811;
    }
    else
    {
        vec4 _830 = _829._m2;
        uvec4 _826 = _28(_830);
        uint _834 = _826[_811 / 2u];
        uint _839 = 16u * (_811 & 1u);
        _822 = (_834 >> _839) & 65535u;
    }
    uint _848 = _822;
    float _850 = SAMPLE_TEXTURE(SAMPLER_2D(_855[_848], _862), _705._m15.zw).x;
    float _882 = pow(_850, 0.125) - 0.800000011920928955078125;
    vec2 _871 = vec2(1.0) / mix(vec2(1.0), vec2(gl_FragmentSizeNV), vec2(_10(_882) / 0.20000000298023223876953125));
    vec2 _890 = dFdx(_705._m15.zw) * _871.x;
    vec2 _898 = dFdy(_705._m15.zw) * _871.y;
    vec2 _906 = TEXTURE_GRAD(SAMPLER_2D(_907[_848], _911), _705._m15.zw, _890, _898).yx;
    vec3 _921 = SAMPLE_TEXTURE(SAMPLER_2D(_922[_848], _926), _705._m15.zw).xyz;
    vec3 _934 = vec3(0.039999999105930328369140625);
    _934 = SAMPLE_TEXTURE(SAMPLER_2D(_937[_848], _941), _705._m15.zw).xyz;
    float _949 = 1.0;
    _949 = SAMPLE_TEXTURE(SAMPLER_2D(_950[_848], _954), _705._m15.zw).x;
    float _962 = SAMPLE_TEXTURE(SAMPLER_2D(_963[_848], _967), _705._m15.zw).x;
    float _975 = SAMPLE_TEXTURE(SAMPLER_2D(_976[_848], _980), _705._m15.zw).x;
    vec3 _988 = SAMPLE_TEXTURE(SAMPLER_2D(_989[_848], _993), _705._m15.zw).xyz;
    _781 = vec4(_921.x, _921.y, _921.z, _781.w);
    _781.w = _906.y;
    _782 = vec4(_934.x, _934.y, _934.z, _782.w);
    _782.w = _975;
    _783 = vec4(_783.x, _906.x, _783.z, _906.y);
    _779.x = _962;
    _779.y = _949;
    _779.z = _975;
    _779.w = _850;
    _780 = vec4(_988.x, _988.y, _988.z, _780.w);
    uint _1026 = 0u;
    vec4 _1027 = vec4(0.0);
    vec4 _1028 = vec4(0.0);
    vec4 _1029 = vec4(0.0);
    vec4 _1030 = vec4(0.0);
    vec4 _1031 = vec4(0.0);
    uint _1032 = _788.x & 7u;
    uint _1042;
    if (_726._m2.x == 0.0)
    {
        _1042 = _1032;
    }
    else
    {
        vec4 _1046 = _829._m2;
        uvec4 _1045 = _28(_1046);
        uint _1050 = _1045[_1032 / 2u];
        uint _1055 = 16u * (_1032 & 1u);
        _1042 = (_1050 >> _1055) & 65535u;
    }
    uint _1063 = _1042;
    vec4 _1065 = vec4(_705._m15.xy, 0.0, _829._m3.x);
    vec3 _1074 = SAMPLE_TEXTURE1(SAMPLER_2D(_922[_1063], _926), _1065.xy, _1065.w).xyz;
    vec2 _1086 = SAMPLE_TEXTURE1(SAMPLER_2D(_907[_1063], _911), _1065.xy, _1065.w).yx;
    vec3 _1098 = vec3(0.039999999105930328369140625);
    _1098 = SAMPLE_TEXTURE1(SAMPLER_2D(_937[_1063], _941), _1065.xy, _1065.w).xyz;
    float _1110 = SAMPLE_TEXTURE1(SAMPLER_2D(_855[_1063], _862), _1065.xy, _1065.w).x;
    float _1122 = 1.0;
    _1122 = SAMPLE_TEXTURE1(SAMPLER_2D(_950[_1063], _954), _1065.xy, _1065.w).x;
    float _1134 = SAMPLE_TEXTURE1(SAMPLER_2D(_963[_1063], _967), _1065.xy, _1065.w).x;
    float _1146 = SAMPLE_TEXTURE1(SAMPLER_2D(_976[_1063], _980), _1065.xy, _1065.w).x;
    vec3 _1158 = SAMPLE_TEXTURE1(SAMPLER_2D(_989[_1063], _993), _1065.xy, _1065.w).xyz;
    _1027 = vec4(_1074.x, _1074.y, _1074.z, _1027.w);
    _1027.w = _1086.y;
    _1028 = vec4(_1098.x, _1098.y, _1098.z, _1028.w);
    _1028.w = _1146;
    _1029 = vec4(_1029.x, _1086.x, _1029.z, _1086.y);
    _1030.x = _1134;
    _1030.y = _1122;
    _1030.z = _1146;
    _1030.w = _1110;
    _1031 = vec4(_1158.x, _1158.y, _1158.z, _1031.w);
    _705._m8 = _1029.wyz;
    float _1203 = _779.y * _829._m4.x;
    _705._m4 = _10(_1203);
    float _1209;
    if (_829._m5.x > 0.0)
    {
        _1209 = _782.x;
    }
    else
    {
        _1209 = 0.0;
    }
    _705._m5 = _1209;
    vec3 _1220;
    if (_829._m5.x > 0.0)
    {
        _1220 = vec3(_782.y);
    }
    else
    {
        _1220 = _782.xyz;
    }
    _782 = vec4(_1220.x, _1220.y, _1220.z, _782.w);
    float _1240 = (1.0 - _705._m4) * _829._m6.x;
    _705._m12 = _10(_1240);
    _705._m10 = vec3(_779.x) * _790;
    _705._m10 *= vec3(_726._m3.x);
    _705._m0 = _781.xyz;
    _705._m2 = _782.xyz;
    _705._m1 = _780.xyz;
    _705._m9 = _779.xyz;
    _705._m3 = _779.w;
    _705._m6 = _783.wyz;
    vec2 _1275 = _717.xy * _1280._m25.xy;
    vec4 _1286 = SAMPLE_TEXTURE(_1288, _1275);
    vec4 _1292 = SAMPLE_TEXTURE(_1293, _1275);
    float _1303 = _1298.x * 0.5;
    float _1297 = 1.0 - _10(_1303);
    float _1309 = _1297 * 2.0;
    float _1316 = (_10(_1309) - (1.0 - _1286.w)) * 1.0;
    float _1306 = _10(_1316);
    float _1325 = (_1297 - (1.0 - _1292.w)) * 1.0;
    float _1318 = _10(_1325);
    vec3 _1329 = _1286.xyz;
    _705._m0 = mix(_705._m0, _54(_1329), vec3(_1306));
    _705._m2 = mix(_705._m2, vec3(0.0199999995529651641845703125), vec3(_1306));
    _705._m3 = mix(_705._m3, 0.64999997615814208984375, _1306);
    _705._m6 = mix(_705._m6, _1292.xyz, vec3(_1318));
    uint _1359 = uint((_1280._m26.x > 0.0) ? 8 : 0);
    float _1366 = 16.0;
    float _1368 = 8.0;
    float _1370 = 24.0;
    vec2 _1379 = _705._m16.xy * _726._m4.xy;
    vec3 _1372;
    _1372 = vec3(_1379.x, _1379.y, _1372.z);
    _1372.y = 1.0 - _1372.y;
    vec2 _1392 = floor(_1372.xy * vec2(_1366, _1368));
    _1372 = vec3(_1392.x, _1392.y, _1372.z);
    float _1396 = _705._m16.z;
    vec4 _1399 = _726._m5;
    float _1402 = 1.0;
    bool _1403 = false;
    float _1395 = _117(_1396, _1399, _1402, _1403);
    float _1405 = log2(max(1.0, _1395 / _726._m6.z)) * _726._m6.w;
    _1372.z = min(_1370 - 1.0, floor(_1405));
    uint _1421 = uint((_1372.x + (_1372.y * _1366)) + ((_1372.z * _1366) * _1368));
    bool _1437 = true;
    vec3 _1440 = _705._m6;
    bool _1443 = _1437;
    _705._m7 = _122(_1440, _1443);
    vec3 _1447 = _705._m7;
    mat3 _1450 = _705._m17;
    _705._m6 = _129(_1447, _1450);
    vec3 _1455 = _705._m8;
    mat3 _1458 = _705._m17;
    bool _1461 = _1437;
    _705._m8 = _135(_1455, _1458, _1461);
    uint _1465 = 0u;
    uint _1466 = 0u;
    uint _1467 = 0u;
    uint _1468 = 0u;
    uint _1469 = 0u;
    uint _1470 = 0u;
    int _1472 = 256;
    _1474 _1476;
    _1476._m0 = _1481._m0[_1421]._m0;
    _1476._m1 = _1481._m0[_1421]._m1;
    int _1490 = _1476._m0 & (~(_1476._m0 >> 31));
    int _1499 = _1476._m1 & (~(_1476._m1 >> 31));
    _1465 = uint((_1490 >> 16) * _1472);
    _1466 = _1465 + uint(_1499 & 255);
    _1467 = _1465;
    _1468 = _1467 + uint((_1499 >> 8) & 255);
    _1469 = _1465;
    _1470 = _1469 + uint((_1499 >> 16) & 255);
    vec3 _1532 = vec3(0.0);
    vec3 _1533 = vec3(_705._m34.x, _705._m34.y, _705._m34.z);
    vec3 _1541 = vec3(_705._m34.w, _705._m35.x, _705._m35.y);
    vec3 _1549 = vec3(_705._m35.z, _705._m35.w, _705._m36.x);
    vec3 _1557 = vec3(_705._m36.y, _705._m36.z, _705._m36.w);
    vec3 _1565 = ((_1533 - (_1541 * _705._m6.y)) + (_1549 * _705._m6.z)) - (_1557 * _705._m6.x);
    float _1589 = _1280._m27.x * _726._m7.x;
    _1532 += max(_1565 * _10(_1589), vec3(0.0));
    vec3 _1595 = vec3(0.0);
    vec3 _1596 = vec3(_705._m34.x, _705._m34.y, _705._m34.z);
    vec3 _1604 = vec3(_705._m34.w, _705._m35.x, _705._m35.y);
    vec3 _1612 = vec3(_705._m35.z, _705._m35.w, _705._m36.x);
    vec3 _1620 = vec3(_705._m36.y, _705._m36.z, _705._m36.w);
    vec3 _1628 = ((_1596 - (_1604 * _705._m8.y)) + (_1612 * _705._m8.z)) - (_1620 * _705._m8.x);
    float _1651 = _1280._m27.x * _726._m7.x;
    _1595 += max(_1628 * _10(_1651), vec3(0.0));
    _1532 = mix(_1532, _1595, vec3(_705._m4));
    float _1668;
    if (dot(_705._m10, vec3(1.0)) > 0.0)
    {
        _1668 = -_705._m3;
    }
    else
    {
        _1668 = _705._m3;
    }
    _705._m3 = _1668;
    _705._m18 = _1532;
    _705._m19 = _1532;
    float _1685 = 1.0;
    uint _1686 = _1469;
    _1722 _1724;
    while (_1686 < _1470)
    {
        uint _1696 = _1700._m0[_1686];
        uint _1705 = (_1696 >> uint(24)) & 4095u;
        uint _1710 = _1705;
        if (_1710 >= _1705)
        {
            _1686++;
        }
        int _1719 = 4;
        int _1720 = 4;
        int _1721 = 3;
        _1724._m0 = _1729._m0[(uint(_1719) * _1710) + 0u].xyz;
        float _1744 = _1729._m0[(uint(_1719) * _1710) + 0u].w;
        _1724._m1 = _21(_1744);
        _1724._m2 = _1729._m0[(uint(_1719) * _1710) + 1u];
        _1724._m3 = _1729._m0[(uint(_1719) * _1710) + 2u];
        _1724._m4 = _1768._m0[(uint(_1720) * _1710) + 0u];
        _1724._m5 = _1768._m0[(uint(_1720) * _1710) + 1u];
        _1724._m6 = _1768._m0[(uint(_1720) * _1710) + 2u];
        float _1798 = _1729._m0[(uint(_1719) * _1710) + 3u].x;
        _1724._m7.x = _21(_1798);
        float _1808 = _1729._m0[(uint(_1719) * _1710) + 3u].y;
        _1724._m7.y = _21(_1808);
        float _1818 = _1729._m0[(uint(_1719) * _1710) + 3u].z;
        _1724._m7.z = _21(_1818);
        float _1828 = _1729._m0[(uint(_1719) * _1710) + 3u].w;
        _1724._m7.w = _21(_1828);
        _1724._m8 = _1837._m0[(uint(_1721) * _1710) + 0u];
        _1724._m9 = _1837._m0[(uint(_1721) * _1710) + 1u];
        _1724._m10 = _1837._m0[(uint(_1721) * _1710) + 2u];
        float _1868 = _1768._m0[(uint(_1720) * _1710) + 3u].x;
        _1724._m11 = _21(_1868);
        float _1878 = _1768._m0[(uint(_1720) * _1710) + 3u].y;
        _1724._m12 = _21(_1878);
        _1724._m13 = _1768._m0[(uint(_1720) * _1710) + 3u].z;
        float _1896 = _1768._m0[(uint(_1720) * _1710) + 3u].w;
        _1724._m14 = _21(_1896);
        vec3 _1901 = vec3((_705._m14.x * _1724._m4.x) + ((_705._m14.y * _1724._m4.y) + ((_705._m14.z * _1724._m4.z) + _1724._m4.w)), (_705._m14.x * _1724._m5.x) + ((_705._m14.y * _1724._m5.y) + ((_705._m14.z * _1724._m5.z) + _1724._m5.w)), (_705._m14.x * _1724._m6.x) + ((_705._m14.y * _1724._m6.y) + ((_705._m14.z * _1724._m6.z) + _1724._m6.w)));
        vec2 _1968 = _1901.xy / vec2(_1901.z);
        _1901 = vec3(_1968.x, _1968.y, _1901.z);
        _1901.z = (_705._m14.x * _1724._m3.x) + ((_705._m14.y * _1724._m3.y) + ((_705._m14.z * _1724._m3.z) + _1724._m3.w));
        float _1992 = 0.0039215688593685626983642578125;
        float _1994 = _1901.x;
        float _1997 = _1901.y;
        float _2000 = _1901.z;
        bool _2005 = _39(_1994, _1997, _2000) < _1992;
        bool _2022;
        if (!_2005)
        {
            float _2009 = _1901.x;
            float _2012 = _1901.y;
            float _2015 = _1901.z;
            _2022 = _34(_2009, _2012, _2015) >= (1.0 - _1992);
        }
        else
        {
            _2022 = _2005;
        }
        if (_2022)
        {
            continue;
        }
        uint _2026 = _1724._m1;
        uint _2030 = _1724._m12;
        vec3 _2029 = _89(_2030);
        float _2034 = _1724._m13;
        vec3 _2037 = _1724._m0;
        uint _2041 = _2026;
        float _2040 = _73(_2041).y;
        vec3 _2045 = (_1901 * 2.0) - vec3(1.0);
        vec3 _2049 = _2045 * sqrt(((vec3(1.0) - ((_2045.yzx * _2045.yzx) * 0.5)) - ((_2045.zxy * _2045.zxy) * 0.5)) + ((((_2045.yzx * _2045.yzx) * _2045.zxy) * _2045.zxy) / vec3(3.0)));
        float _2093 = 1.0 - ((length(_2049) - _2040) / ((1.0 - _2040) + 9.9999999747524270787835121154785e-07));
        float _2082 = _10(_2093);
        _2082 *= _2082;
        _2082 *= (_1724._m8.w * _1685);
        _1685 *= (1.0 - _2082);
        if (_2082 <= (_1992 * 4.0))
        {
            continue;
        }
        vec3 _2115 = _2029;
        uint _2118 = _2026;
        float _2117 = _76(_2118).z;
        vec3 _2122 = vec3(0.0);
        vec3 _2123 = vec3(0.0);
        vec3 _2124 = _705._m6;
        _2124.x = dot(_1724._m2.xy, _705._m6.xy);
        _2124.y = dot(_1724._m2.zw, _705._m6.xy);
        vec3 _2143 = reflect(-_705._m13, _705._m6);
        vec3 _2150 = (_1724._m9.xyz - _705._m14) / _2143;
        vec3 _2159 = (_1724._m8.xyz - _705._m14) / _2143;
        vec3 _2168 = max(_2150, _2159);
        float _2173 = _2168.x;
        float _2176 = _2168.y;
        float _2179 = _2168.z;
        float _2172 = _39(_2173, _2176, _2179);
        vec3 _2183 = _705._m14 + (_2143 * _2172);
        vec3 _2190 = normalize(_2183 - _2037);
        vec3 _2195 = _2190;
        _2195.x = dot(_1724._m2.xy, _2190.xy);
        _2195.y = dot(_1724._m2.zw, _2190.xy);
        float _2217 = dot(_705._m13, _705._m6);
        float _2211 = _10(_2217);
        float _2219 = 0.0;
        float _2220 = 6.0;
        float _2222 = max(_2219, _2220 - (_2220 * abs(_705._m3)));
        _2123 = textureLod(_2235, vec4(_2195, _2117), _2222).xyz * _2034;
        float _2252 = _2211;
        float _2254 = abs(_705._m3);
        vec3 _2255 = _705._m2;
        vec3 _2248 = _108(_2252, _2254, _2255);
        _2123 *= _2248;
        float _2266 = _2082;
        _705._m20 += ((_2123 * _2115) * _10(_2266));
        if (_1685 <= (_1992 * 4.0))
        {
            break;
        }
    }
    uint _2281 = _1465;
    _1722 _2310;
    vec3 _2595;
    float _2671;
    float _2689;
    _3060 _3062;
    uint _3183;
    _3060 _3206;
    while (_2281 < _1466)
    {
        uint _2291 = _1700._m0[_2281];
        uint _2295 = _2291 & 4095u;
        uint _2298 = _2295;
        if (_2298 >= _2295)
        {
            _2281++;
        }
        int _2307 = 4;
        int _2308 = 4;
        int _2309 = 3;
        _2310._m0 = _1729._m0[(uint(_2307) * _2298) + 0u].xyz;
        float _2325 = _1729._m0[(uint(_2307) * _2298) + 0u].w;
        _2310._m1 = _21(_2325);
        _2310._m2 = _1729._m0[(uint(_2307) * _2298) + 1u];
        _2310._m3 = _1729._m0[(uint(_2307) * _2298) + 2u];
        _2310._m4 = _1768._m0[(uint(_2308) * _2298) + 0u];
        _2310._m5 = _1768._m0[(uint(_2308) * _2298) + 1u];
        _2310._m6 = _1768._m0[(uint(_2308) * _2298) + 2u];
        float _2375 = _1729._m0[(uint(_2307) * _2298) + 3u].x;
        _2310._m7.x = _21(_2375);
        float _2385 = _1729._m0[(uint(_2307) * _2298) + 3u].y;
        _2310._m7.y = _21(_2385);
        float _2395 = _1729._m0[(uint(_2307) * _2298) + 3u].z;
        _2310._m7.z = _21(_2395);
        float _2405 = _1729._m0[(uint(_2307) * _2298) + 3u].w;
        _2310._m7.w = _21(_2405);
        _2310._m8 = _1837._m0[(uint(_2309) * _2298) + 0u];
        _2310._m9 = _1837._m0[(uint(_2309) * _2298) + 1u];
        _2310._m10 = _1837._m0[(uint(_2309) * _2298) + 2u];
        float _2439 = _1768._m0[(uint(_2308) * _2298) + 3u].x;
        _2310._m11 = _21(_2439);
        float _2449 = _1768._m0[(uint(_2308) * _2298) + 3u].y;
        _2310._m12 = _21(_2449);
        _2310._m13 = _1768._m0[(uint(_2308) * _2298) + 3u].z;
        float _2467 = _1768._m0[(uint(_2308) * _2298) + 3u].w;
        _2310._m14 = _21(_2467);
        float _2472 = 0.0039215688593685626983642578125;
        vec4 _2473 = vec4(_705._m14, 1.0);
        float _2480 = 1.0 / dot(_2473, _2310._m6);
        vec3 _2486 = vec3(dot(_2473, _2310._m4) * _2480, dot(_2473, _2310._m5) * _2480, dot(_2473, _2310._m3));
        uint _2504 = _2310._m1;
        uint _2507 = _1359;
        _2507 |= 64u;
        float _2512 = _2486.x;
        float _2515 = _2486.y;
        float _2518 = _2486.z;
        bool _2523 = _39(_2512, _2515, _2518) <= _2472;
        bool _2540;
        if (!_2523)
        {
            float _2527 = _2486.x;
            float _2530 = _2486.y;
            float _2533 = _2486.z;
            _2540 = _34(_2527, _2530, _2533) >= (1.0 - _2472);
        }
        else
        {
            _2540 = _2523;
        }
        bool _2548;
        if (!_2540)
        {
            _2548 = (_2504 & _2507) != 0u;
        }
        else
        {
            _2548 = _2540;
        }
        if (_2548)
        {
            continue;
        }
        if ((_2504 & 3u) == 2u)
        {
            vec2 _2567 = fract((_2486.xy * _726._m8.xy) + _726._m8.zw);
            _2486 = vec3(_2567.x, _2567.y, _2486.z);
        }
        vec3 _2570 = _2310._m0;
        float _2573 = 1.0;
        float _2574 = 1.0;
        vec3 _2575 = vec3(0.0, 0.0, 1.0);
        vec3 _2576 = vec3(0.0, 0.0, 1.0);
        uint _2577 = _2310._m1;
        vec3 _2580 = (_2486 * 2.0) - vec3(1.0);
        vec2 _2585 = _2486.xy;
        vec3 _2588 = _2310._m10.xyz;
        if ((_2577 & 3u) == 2u)
        {
            _2595 = _2588;
        }
        else
        {
            _2595 = normalize(_2570 - _705._m14);
        }
        _2575 = _2595;
        _2575 = _2575;
        float _2612 = dot(_705._m6, _2575);
        float _2607 = _10(_2612);
        uvec2 _2615 = _2310._m7.zw;
        vec4 _2614 = _86(_2615);
        float _2620 = TEXTURE_LOD(_2621, vec4((_2585 * _2614.xy) + _2614.zw, 0.0, 0.0).xy, vec4((_2585 * _2614.xy) + _2614.zw, 0.0, 0.0).w).x;
        float _2647 = _2620 * _2620;
        uint _2651 = _2577 & 3u;
        bool _2656 = _2651 == 1u;
        bool _2668;
        if (!_2656)
        {
            bool _2661 = _2651 == 0u;
            bool _2667;
            if (_2661)
            {
                _2667 = _2310._m8.z != 0.0;
            }
            else
            {
                _2667 = _2661;
            }
            _2668 = _2667;
        }
        else
        {
            _2668 = _2656;
        }
        bool _2654 = _2668;
        if (_2654)
        {
            float _2674 = _2310._m8.w;
            _2671 = _10(_2674);
        }
        else
        {
            _2671 = 0.5;
        }
        float _2669 = _2671;
        bool _2682 = _2651 == 0u;
        bool _2688;
        if (_2682)
        {
            _2688 = _2310._m8.z != 0.0;
        }
        else
        {
            _2688 = _2682;
        }
        if (_2688)
        {
            float _2697 = sqrt(dot(_2580, _2580));
            _2689 = min(0.9921875, _10(_2697));
        }
        else
        {
            _2689 = _2486.z;
        }
        float _2680 = _2689;
        uvec2 _2705 = _2310._m7.xy;
        vec4 _2704 = _86(_2705);
        vec2 _2710 = vec2(_2680, _2669);
        float _2714 = TEXTURE_LOD(_2621, vec4((_2710 * _2704.xy) + _2704.zw, 0.0, 0.0).xy, vec4((_2710 * _2704.xy) + _2704.zw, 0.0, 0.0).w).x;
        _2714 *= _2714;
        _2573 = _2714 * _2647;
        if ((_2577 & 48u) != 0u)
        {
            vec4 _2752 = _2310._m10;
            vec4 _2755 = _2310._m8;
            vec4 _2758 = _2310._m9;
            float _2761 = dot(_705._m14, _2752.xyz) + _2752.w;
            if (_2761 < 0.0)
            {
                continue;
            }
            float _2775 = length(_2752.xyz);
            float _2782 = _2761 * 50.0;
            float _2779 = _10(_2782);
            _2573 *= (_2779 * _2779);
            _2761 /= _2775;
            _2752 /= vec4(_2775);
            vec3 _2796 = reflect(-_705._m13, _705._m6);
            if (dot(_2796, _2752.xyz) > 0.0)
            {
                _2796 = reflect(_2796, _2752.xyz);
            }
            float _2814 = dot(_2796, _2752.xyz);
            float _2819 = _2761 / _2814;
            vec3 _2823 = _705._m14 - (_2796 * _2819);
            vec3 _2830 = _2823 - _2570;
            float _2834 = dot(_2830, _2755.xyz) / _2755.w;
            float _2842 = dot(_2830, _2758.xyz) / _2758.w;
            if ((_2577 & 48u) == 32u)
            {
                vec2 _2856 = vec2(_2834, _2842);
                float _2860 = 1.0 / max(1.0, length(vec2(_2834, _2842)));
                _2834 *= (_2860 * _2755.w);
                _2842 *= (_2860 * _2758.w);
            }
            else
            {
                float _2882 = abs(_2834);
                float _2884 = _2834;
                _2834 = (_10(_2882) * _65(_2884)) * _2755.w;
                float _2893 = abs(_2842);
                float _2895 = _2842;
                _2842 = (_10(_2893) * _65(_2895)) * _2758.w;
            }
            vec3 _2902 = (_2755.xyz * _2834) + (_2758.xyz * _2842);
            _2570 += _2902;
            _2575 = normalize(_2570 - _705._m14);
            _2575 = _2575;
        }
        else
        {
            uint _2922 = (_2310._m14 >> uint(16)) & 255u;
            if (_2922 == 0u)
            {
                vec4 _2931 = _2310._m9;
                if (dot(_2931.xyz, _705._m14) < (_2931.w - _2472))
                {
                    continue;
                }
            }
            else
            {
                if (_2922 == 1u)
                {
                    vec3 _2952 = _2310._m9.xyz;
                    float _2957 = _2310._m9.w;
                    uint _2961 = _21(_2957);
                    vec3 _2956 = (((_80(_2961) * 2.0) - vec3(1.0)) * _2952) + _2570;
                    vec3 _2970 = abs((_705._m14 - _2956) / _2952);
                    float _2978 = _2970.x;
                    float _2981 = _2970.y;
                    float _2984 = _2970.z;
                    if (_34(_2978, _2981, _2984) > 1.0)
                    {
                        continue;
                    }
                }
            }
        }
        if (_2573 <= (_2472 / 256.0))
        {
            continue;
        }
        float _3000 = 1.0;
        if ((_2504 & 4u) != 0u)
        {
            float _3007 = float(_2310._m14 & 255u) / 255.0;
            float _3013 = 0.00200000009499490261077880859375;
            vec3 _3015 = _705._m14 + (_705._m6 * _3013);
            uint _3023 = 0u;
            if ((_2504 & 3u) == 0u)
            {
                vec3 _3029 = _3015 - _2310._m2.xyz;
                float _3035 = _3029.x;
                float _3038 = _3029.y;
                float _3041 = _3029.z;
                _3023 = _45(_3035, _3038, _3041);
            }
            else
            {
                if ((_2504 & 3u) == 2u)
                {
                    float _3051 = 0.0;
                    for (; _3023 < 3u; _3023++)
                    {
                        int _3059 = 5;
                        _3062._m0 = _3066._m0[(uint(_3059) * ((_2504 >> uint(22)) + _3023)) + 0u];
                        _3062._m1 = _3066._m0[(uint(_3059) * ((_2504 >> uint(22)) + _3023)) + 1u];
                        _3062._m2 = _3066._m0[(uint(_3059) * ((_2504 >> uint(22)) + _3023)) + 2u];
                        _3062._m3 = _3066._m0[(uint(_3059) * ((_2504 >> uint(22)) + _3023)) + 3u];
                        _3062._m4 = _3066._m0[(uint(_3059) * ((_2504 >> uint(22)) + _3023)) + 4u];
                        vec2 _3123 = vec2(dot(_3015, _3062._m0.xyz) + _3062._m0.w, dot(_3015, _3062._m1.xyz) + _3062._m1.w);
                        _3123 = abs((_3123 * 2.0) - vec2(1.0));
                        bool _3148 = _3123.x < 1.0;
                        bool _3154;
                        if (_3148)
                        {
                            _3154 = _3123.y < 1.0;
                        }
                        else
                        {
                            _3154 = _3148;
                        }
                        if (_3154)
                        {
                            _3051 = (1.0 - max(_3123.x, _3123.y)) * _726._m9.w;
                            break;
                        }
                    }
                    _3023 = min(2u, _3023);
                    uint _3171 = uint(_705._m16.x) ^ (uint(_705._m16.y) << uint(1));
                    if (_726._m10.w > 0.0)
                    {
                        _3183 = uint(_726._m11.x);
                    }
                    else
                    {
                        _3183 = 0u;
                    }
                    _3171 ^= _3183;
                    _3023 += uint(int(((float(_3171 & 3u) * 0.25) + 0.125) > _3051));
                }
            }
            int _3205 = 5;
            _3206._m0 = _3066._m0[(uint(_3205) * ((_2504 >> uint(22)) + _3023)) + 0u];
            _3206._m1 = _3066._m0[(uint(_3205) * ((_2504 >> uint(22)) + _3023)) + 1u];
            _3206._m2 = _3066._m0[(uint(_3205) * ((_2504 >> uint(22)) + _3023)) + 2u];
            _3206._m3 = _3066._m0[(uint(_3205) * ((_2504 >> uint(22)) + _3023)) + 3u];
            _3206._m4 = _3066._m0[(uint(_3205) * ((_2504 >> uint(22)) + _3023)) + 4u];
            vec4 _3262 = vec4((_3015.x * _3206._m0.x) + ((_3015.y * _3206._m0.y) + ((_3015.z * _3206._m0.z) + _3206._m0.w)), (_3015.x * _3206._m1.x) + ((_3015.y * _3206._m1.y) + ((_3015.z * _3206._m1.z) + _3206._m1.w)), (_3015.x * _3206._m2.x) + ((_3015.y * _3206._m2.y) + ((_3015.z * _3206._m2.z) + _3206._m2.w)), (_3015.x * _3206._m3.x) + ((_3015.y * _3206._m3.y) + ((_3015.z * _3206._m3.z) + _3206._m3.w)));
            vec3 _3349 = _3262.xyz / vec3(_3262.w);
            _3262 = vec4(_3349.x, _3349.y, _3349.z, _3262.w);
            bool _3357 = min(_3262.x, _3262.y) > 0.0;
            bool _3366;
            if (_3357)
            {
                _3366 = max(_3262.x, _3262.y) < 1.0;
            }
            else
            {
                _3366 = _3357;
            }
            if (_3366)
            {
                vec2 _3378 = (_3262.xy * _3206._m4.xy) + _3206._m4.zw;
                _3262 = vec4(_3378.x, _3378.y, _3262.z, _3262.w);
                if (false)
                {
                    _3000 = textureLod(_3386, vec3(_3262.xyz.xy, _3262.xyz.z), 0.0);
                }
                else
                {
                    vec2 _3393 = (_3262.xy * _726._m12.xy) + vec2(0.5);
                    vec2 _3402 = floor(_3393);
                    vec2 _3405 = _3393 - _3402;
                    _3402 -= vec2(0.5);
                    vec2 _3412 = vec2(4.0) - (_3405 * 3.0);
                    vec2 _3417 = vec2(7.0);
                    vec2 _3420 = vec2(1.0) + (_3405 * 3.0);
                    vec2 _3425 = (_3402 + (((vec2(3.0) - (_3405 * 2.0)) / _3412) - vec2(2.0))) * _726._m12.zw;
                    vec2 _3440 = (_3402 + ((vec2(3.0) + _3405) / _3417)) * _726._m12.zw;
                    vec2 _3452 = (_3402 + ((_3405 / _3420) + vec2(2.0))) * _726._m12.zw;
                    vec3 _3476 = vec3(_3425.x, _3425.y, _3262.z);
                    _3000 = (_3412.x * _3412.y) * textureLod(_3386, vec3(_3476.xy, _3476.z), 0.0);
                    vec3 _3492 = vec3(_3440.x, _3425.y, _3262.z);
                    _3000 += ((_3417.x * _3412.y) * textureLod(_3386, vec3(_3492.xy, _3492.z), 0.0));
                    vec3 _3510 = vec3(_3452.x, _3425.y, _3262.z);
                    _3000 += ((_3420.x * _3412.y) * textureLod(_3386, vec3(_3510.xy, _3510.z), 0.0));
                    vec3 _3528 = vec3(_3425.x, _3440.y, _3262.z);
                    _3000 += ((_3412.x * _3417.y) * textureLod(_3386, vec3(_3528.xy, _3528.z), 0.0));
                    vec3 _3546 = vec3(_3440.x, _3440.y, _3262.z);
                    _3000 += ((_3417.x * _3417.y) * textureLod(_3386, vec3(_3546.xy, _3546.z), 0.0));
                    vec3 _3564 = vec3(_3452.x, _3440.y, _3262.z);
                    _3000 += ((_3420.x * _3417.y) * textureLod(_3386, vec3(_3564.xy, _3564.z), 0.0));
                    vec3 _3582 = vec3(_3425.x, _3452.y, _3262.z);
                    _3000 += ((_3412.x * _3420.y) * textureLod(_3386, vec3(_3582.xy, _3582.z), 0.0));
                    vec3 _3600 = vec3(_3440.x, _3452.y, _3262.z);
                    _3000 += ((_3417.x * _3420.y) * textureLod(_3386, vec3(_3600.xy, _3600.z), 0.0));
                    vec3 _3618 = vec3(_3452.x, _3452.y, _3262.z);
                    _3000 += ((_3420.x * _3420.y) * textureLod(_3386, vec3(_3618.xy, _3618.z), 0.0));
                    _3000 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _3000 = float((_2504 & 3u) == 2u);
            }
            float _3632 = float((_2504 >> uint(16)) & 63u) / 63.0;
            float _3646 = ((_3000 * _3632) + 1.0) - _3632;
            _3000 = _10(_3646);
        }
        uint _3649 = _2310._m12;
        vec3 _3648 = (_89(_3649) * _3000) * _2573;
        _2574 *= _2310._m13;
        vec3 _3661 = _3648;
        vec3 _3663 = _2575;
        float _3670 = dot(_705._m6, _3663);
        float _3665 = _10(_3670);
        vec3 _3676 = _705._m6;
        vec3 _3679 = _705._m13;
        vec3 _3682 = _2575;
        vec3 _3684 = _705._m2;
        float _3687 = abs(_705._m3);
        vec3 _3672 = _102(_3676, _3679, _3682, _3684, _3687);
        _705._m20 += (((_3672 * _2574) * _3661) * _3665);
        vec3 _3700 = mix(_3661, vec3(0.0), bvec3((_2504 & 256u) > 0u));
        vec3 _3709 = -_2575;
        vec3 _3712 = mix(_705._m6, _705._m8, _829._m7.xxx);
        vec3 _3721 = mix(_705._m6, _705._m8, _829._m7.yyy);
        vec3 _3730 = mix(_705._m6, _705._m8, _829._m7.zzz);
        vec3 _3750 = vec3(dot(_3712, _3663), dot(_3721, _3663), dot(_3730, _3663));
        vec3 _3739 = _16(_3750);
        float _3759 = dot(_705._m13, _3709);
        vec3 _3768 = (_829._m8.xyz * pow(_10(_3759), _829._m8.w)) * _705._m5;
        _3739 += _16(_3768);
        _3739 = mix(vec3(_3665), _3739, vec3(_705._m4));
        _705._m19 += (_3700 * _3739);
    }
    _705._m19 = _705._m19;
    _705._m20 += _705._m10;
    float _3795 = 0.064999997615814208984375;
    float _3797 = 1.0 + _3795;
    bool _3800 = false;
    uint _3806;
    if (_726._m13.w > 0.00999999977648258209228515625)
    {
        _3806 = uint(_726._m13.x);
    }
    else
    {
        _3806 = 0u;
    }
    uint _3801 = _3806;
    _3824 _3826;
    for (uint _3814 = 0u; _3814 < _3801; _3814++)
    {
        int _3823 = 4;
        _3826._m0 = _3830._m0[(uint(_3823) * _3814) + 0u];
        _3826._m1 = _3830._m0[(uint(_3823) * _3814) + 1u];
        _3826._m2 = _3830._m0[(uint(_3823) * _3814) + 2u];
        float _3860 = _3830._m0[(uint(_3823) * _3814) + 3u].x;
        _3826._m3 = _21(_3860);
        float _3870 = _3830._m0[(uint(_3823) * _3814) + 3u].y;
        _3826._m4 = _21(_3870);
        float _3880 = _3830._m0[(uint(_3823) * _3814) + 3u].z;
        _3826._m5 = _21(_3880);
        vec4 _3885 = vec4(_705._m14, 1.0);
        vec3 _3892 = vec3(dot(_3885, _3826._m1), dot(_3885, _3826._m2), dot(_3885, _3826._m0));
        float _3906 = _3892.x;
        float _3909 = _3892.y;
        float _3912 = _3892.z;
        bool _3916 = _39(_3906, _3909, _3912) >= 0.0;
        bool _3925;
        if (_3916)
        {
            _3925 = max(_3892.x, _3892.y) < 1.0;
        }
        else
        {
            _3925 = _3916;
        }
        bool _3932;
        if (_3925)
        {
            _3932 = _3892.z < _3797;
        }
        else
        {
            _3932 = _3925;
        }
        if (_3932)
        {
            float _3935 = _3892.z;
            vec4 _3938 = vec4(_705._m14, 1.0);
            vec2 _3945 = vec2(0.0);
            _3945 = (((_3938.xy - _726._m14.zw) / vec2(16.0)) * 0.5) + vec2(0.5);
            float _3958 = 0.000244140625;
            float _3964 = abs(_705._m6.z) * 2.0;
            _3958 *= _10(_3964);
            vec3 _3968 = vec3(TEXTURE_LOD(_3969, vec4(_3945 + vec2(_3958), 0.0, 0.0).xy, vec4(_3945 + vec2(_3958), 0.0, 0.0).w).x, TEXTURE_LOD(_3969, vec4(_3945, 0.0, 0.0).xy, vec4(_3945, 0.0, 0.0).w).x, TEXTURE_LOD(_3969, vec4(_3945 - vec2(_3958), 0.0, 0.0).xy, vec4(_3945 - vec2(_3958), 0.0, 0.0).w).x);
            float _4032 = 2.0 - (2.0 * (length(_3938.xy - _726._m14.zw) / 16.0));
            _3968 *= _10(_4032);
            float _4039 = 1.0 - _3935;
            float _4036 = smoothstep(0.0, 0.00999999977648258209228515625, _10(_4039));
            float _4050 = (_705._m6.z * 0.800000011920928955078125) + 0.20000000298023223876953125;
            vec3 _4042 = (_3968 * _4036) * _10(_4050);
            float _4059 = _3797 - _3935;
            float _4053 = (1.0 - _4036) * smoothstep(0.0, 0.00999999977648258209228515625, _10(_4059));
            float _4074 = ((-_705._m6.z) * 0.89999997615814208984375) + 0.100000001490116119384765625;
            vec3 _4063 = (_3968 * _4053) * _10(_4074);
            _3968 = _4042 + _4063;
            float _4085 = 1.02499997615814208984375 - _3935;
            float _4080 = smoothstep(0.0, 0.02999999932944774627685546875, _10(_4085));
            float _4088 = _726._m13.w;
            _705._m19 = mix(_705._m19, (_705._m19 * _3968) + (_705._m19 * mix(1.0, 0.5, _4080)), vec3(_4088));
            break;
        }
    }
    _705._m19 *= _705._m0;
    _705._m21 = _705._m19 + _705._m20;
    if (_1280._m28.x < 1.0)
    {
        vec2 _4128 = gl_FragCoord.xy * 0.00390625;
        float _4133 = TEXTURE_LOD(_4134, vec4(_717.xy * _829._m9.xy, 0.0, 0.0).xy, vec4(_717.xy * _829._m9.xy, 0.0, 0.0).w).x;
        float _4166 = abs(clamp((_1280._m28.x - (_4133 * 0.5)) - 0.100000001490116119384765625, -1.0, 0.0));
        _4133 = _10(_4166);
        _4133 *= 600.0;
        _705._m19 += (vec3(_4133) * vec3(1.0, 0.00999999977648258209228515625, 0.0));
    }
    vec3 _4185 = _705._m19 + _705._m20;
    _4180 = vec4(_4185.x, _4185.y, _4185.z, _4180.w);
    vec3 _4189 = _705._m6;
    bool _4192 = false;
    vec2 _4193 = _146(_4189, _4192);
    _4188 = vec4(_4193.x, _4193.y, _4188.z, _4188.w);
    float _4197 = _705._m2.x;
    float _4201 = _705._m2.y;
    float _4205 = _705._m2.z;
    float _4209 = _705._m3;
    _4196 = vec4(_68(_4197), _68(_4201), _68(_4205), _149(_4209));
    vec3 _4220 = _4180.xyz + _1280._m29.xyz;
    _4180 = vec4(_4220.x, _4220.y, _4220.z, _4180.w);
}

