#version 450
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////

struct _653
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    float _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    vec3 _m9;
    vec3 _m10;
    float _m11;
    float _m12;
    vec3 _m13;
    vec3 _m14;
    vec4 _m15;
    vec4 _m16;
    mat3 _m17;
    vec3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    vec3 _m26;
    vec3 _m27;
    uvec4 _m28;
    uvec4 _m29;
    uvec4 _m30;
    vec3 _m31;
    vec3 _m32;
    ivec3 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    float _m37;
    uint _m38;
};

struct _915
{
    int _m0;
    int _m1;
};

struct _918
{
    int _m0;
    int _m1;
};

struct _1094
{
    vec3 _m0;
    uint _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    uvec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    uint _m11;
    uint _m12;
    float _m13;
    uint _m14;
};

struct _2433
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 20, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 0, binding = 0, std140) uniform _674_676
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
} _676;

layout(set = 2, binding = 0, std140) uniform _757_759
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
} _759;

layout(set = 1, binding = 0, std140) uniform _806_808
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
} _808;

layout(set = 0, binding = 4, std430) restrict readonly buffer _920_922
{
    _918 _m0[];
} _922;

layout(set = 0, binding = 5, std430) restrict readonly buffer _1070_1072
{
    uint _m0[];
} _1072;

layout(set = 0, binding = 6, std140) uniform _1099_1101
{
    vec4 _m0[4096];
} _1101;

layout(set = 0, binding = 7, std140) uniform _1138_1140
{
    vec4 _m0[4096];
} _1140;

layout(set = 0, binding = 8, std140) uniform _1207_1209
{
    vec4 _m0[3072];
} _1209;

layout(set = 0, binding = 11, std140) uniform _2437_2439
{
    vec4 _m0[4095];
} _2439;

layout(set = 0, binding = 1, std430) restrict readonly buffer _3591_3593
{
    vec4 _m0[];
} _3593;

layout(push_constant, std430) uniform _3587_3589
{
    int _m0;
    int _m1;
} _3589;

layout(set = 2, binding = 1) uniform SAMPLER_2D _754;
layout(set = 2, binding = 2) uniform SAMPLER_2D _782;
layout(set = 0, binding = 9) uniform samplerCubeArray _1607;
layout(set = 0, binding = 10) uniform SAMPLER_2D _1994;
layout(set = 0, binding = 12) uniform sampler2DShadow _2760;
layout(set = 2, binding = 3) uniform SAMPLER_2D _3399;
layout(set = 2, binding = 4) uniform SAMPLER_2D _3565;
layout(set = 0, binding = 2) uniform sampler3D _3597;
layout(set = 0, binding = 3) uniform sampler3D _3598;

layout(location = 2) in vec4 _667;
layout(location = 6) in vec4 _681;
layout(location = 3) in vec4 _693;
layout(location = 4) in vec4 _696;
layout(location = 5) in vec4 _699;
layout(location = 10) in vec4 _717;
layout(location = 11) in vec4 _721;
layout(location = 12) in vec4 _725;
layout(location = 7) in vec4 _3401;
layout(location = 0) out vec4 _3522;
layout(location = 1) out vec4 _3530;
layout(location = 2) out vec4 _3538;

float _259;

float _52(float _51)
{
    if (_51 <= 0.040449999272823333740234375)
    {
        return _51 / 12.9200000762939453125;
    }
    else
    {
        return pow((_51 / 1.05499994754791259765625) + 0.0521326996386051177978515625, 2.400000095367431640625);
    }
}

vec3 _55(vec3 _54)
{
    float _261 = _54.x;
    vec3 _260;
    _260.x = _52(_261);
    float _267 = _54.y;
    _260.y = _52(_267);
    float _273 = _54.z;
    _260.z = _52(_273);
    return _260;
}

vec4 _59(vec4 _58)
{
    vec3 _283 = _58.xyz;
    vec4 _282 = vec4(_55(_283), 1.0);
    float _291 = _58.w;
    _282.w = _52(_291);
    return _282;
}

vec4 _62(vec4 _61)
{
    vec4 _300 = _61;
    return _59(_300);
}

vec4 _107(SAMPLER_2D _105, vec2 _106)
{
    vec4 _403 = SAMPLE_TEXTURE(_105, _106);
    vec4 _407 = _403;
    _403 = _62(_407);
    return _403;
}

float _14(float _13)
{
    return clamp(_13, 0.0, 1.0);
}

float _130(float _126, vec4 _127, float _128, bool _129)
{
    float _506 = _127.w / (_126 + _127.z);
    return _506 * _128;
}

vec3 _135(vec3 _133, bool _134)
{
    vec3 _519 = (_133 * 2.0) - vec3(1.0);
    float _536 = (1.0 - (_519.x * _519.x)) - (_519.y * _519.y);
    _519.z = sqrt(_14(_536));
    if (_134 == false)
    {
        _519.z = -_519.z;
    }
    return _519;
}

vec3 _142(vec3 _140, mat3 _141)
{
    return normalize(vec3(dot(_140, _141[0]), dot(_140, _141[1]), dot(_140, _141[2])));
}

uint _32(float _31)
{
    return floatBitsToUint(_31);
}

float _43(float _40, float _41, float _42)
{
    return min(_40, min(_41, _42));
}

float _38(float _35, float _36, float _37)
{
    return max(_35, max(_36, _37));
}

vec4 _84(uint _83)
{
    return unpackUnorm4x8(_83).wzyx;
}

float _68(float _67)
{
    return exp2(_67);
}

vec3 _110(uint _109)
{
    uint _414 = _109;
    vec4 _413 = _84(_414);
    float _425 = (_413.w * 255.0) - 128.0;
    return _413.xyz * _68(_425);
}

vec4 _87(uint _86)
{
    return vec4(float((_86 >> uint(24)) & 255u), float((_86 >> uint(16)) & 255u), float((_86 >> uint(8)) & 255u), float(_86 & 255u));
}

vec3 _121(float _118, float _119, vec3 _120)
{
    float _458 = 0.0949999988079071044921875 + (_119 * (0.60000002384185791015625 + (4.190000057220458984375 * _119)));
    float _468 = _118 + 0.02500000037252902984619140625;
    float _472 = (9.5 * _119) * _118;
    float _486 = 1.0 - (14.0 * _118);
    float _478 = (_458 * _468) * _68(_486);
    float _493 = -_472;
    float _489 = 0.4000000059604644775390625 + (0.60000002384185791015625 * (1.0 - _68(_493)));
    return mix(vec3(_478), vec3(_489), _120);
}

vec4 _97(uvec2 _96)
{
    return vec4(float((_96.x >> uint(16)) & 65535u), float(_96.x & 65535u), float((_96.y >> uint(16)) & 65535u), float(_96.y & 65535u)) * 3.0518509447574615478515625e-05;
}

float _76(float _75)
{
    return (step(0.0, _75) * 2.0) - 1.0;
}

vec3 _91(uint _90)
{
    return vec3(float((_90 >> uint(21)) & 2047u), float((_90 >> uint(10)) & 2047u), float(_90 & 1023u)) / vec3(2047.0, 2047.0, 1023.0);
}

uint _49(float _46, float _47, float _48)
{
    bool _200 = abs(_48) >= abs(_46);
    bool _208;
    if (_200)
    {
        _208 = abs(_48) >= abs(_47);
    }
    else
    {
        _208 = _200;
    }
    if (_208)
    {
        return uint((_48 < 0.0) ? 5 : 4);
    }
    if (abs(_47) >= abs(_46))
    {
        return uint((_47 < 0.0) ? 3 : 2);
    }
    return uint(int(_46 < 0.0));
}

float _65(float _64)
{
    return _64 * _64;
}

float _73(float _71, float _72)
{
    return pow(_71, _72);
}

vec3 _20(vec3 _19)
{
    return clamp(_19, vec3(0.0), vec3(1.0));
}

vec3 _115(vec3 _113, float _114)
{
    float _437 = 50.0 * dot(_113, vec3(0.33329999446868896484375));
    float _430 = _14(_437);
    float _446 = 1.0 - _114;
    float _449 = _14(_446);
    float _450 = 5.0;
    vec3 _454 = _113 + ((vec3(_430) - _113) * _73(_449, _450));
    return _20(_454);
}

float _27(vec4 _25, vec4 _26)
{
    return dot(_25, _26);
}

void _10(float _9)
{
    if (_9 < 0.0)
    {
        discard;
    }
}

vec2 _146(vec2 _145)
{
    return (vec2(1.0) - abs(_145.yx)) * vec2((_145.x >= 0.0) ? 1.0 : (-1.0), (_145.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _151(inout vec3 _149, bool _150)
{
    _149 /= vec3((abs(_149.x) + abs(_149.y)) + abs(_149.z));
    vec2 _603;
    if (_149.z >= 0.0)
    {
        _603 = _149.xy;
    }
    else
    {
        vec2 _609 = _149.xy;
        _603 = _146(_609);
    }
    _149 = vec3(_603.x, _603.y, _149.z);
    if (_150)
    {
        vec2 _624 = (_149.xy * 0.5) + vec2(0.5);
        _149 = vec3(_624.x, _624.y, _149.z);
    }
    return _149.xy;
}

float _79(float _78)
{
    return sqrt(_78);
}

float _154(float _153)
{
    float _634 = abs(_153);
    float _631 = _79(_634);
    float _638;
    if (_153 > 0.0)
    {
        _638 = _631;
    }
    else
    {
        _638 = -_631;
    }
    return (_638 * 0.5) + 0.5;
}

void main()
{
    float _650 = 0.0;
    _653 _655 = _653(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 1.0, 0u);
    _655._m15 = _667;
    _655._m16 = gl_FragCoord;
    _655._m14 = _676._m4.xyz + _681.xyz;
    _655._m13 = normalize(-_681.xyz);
    _655._m17 = mat3(vec3(_693.xyz), vec3(_696.xyz), vec3(_699.xyz));
    _655._m34 = _717;
    _655._m35 = _721;
    _655._m36 = _725;
    uint _728 = 0u;
    vec4 _729 = vec4(0.0);
    vec4 _730 = vec4(0.0);
    vec4 _731 = vec4(0.0);
    vec4 _732 = vec4(0.0);
    vec4 _733 = vec4(0.0);
    _655._m0 = _731.xyz;
    _655._m2 = _732.xyz;
    _655._m1 = _730.xyz;
    _655._m9 = _729.xyz;
    _655._m3 = _729.w;
    _655._m6 = _733.wyz;
    vec2 _764 = _667.xy * _759._m2.xy;
    float _769 = _107(_754, _764).x * 4.0;
    _650 = _14(_769);
    _655._m2 = _759._m3.xxx;
    _655._m3 = _759._m3.y;
    _655._m6 = vec3(0.5, 0.5, 1.0);
    vec4 _798 = SAMPLE_TEXTURE1(_782, vec4(_667.xy, 0.0, -2.0).xy, vec4(_667.xy, 0.0, -2.0).w);
    vec3 _781 = _62(_798).xyz;
    _655._m0 = _781;
    _655._m11 = 1.0;
    uint _805 = uint((_808._m8.x > 0.0) ? 8 : 0);
    float _814 = 16.0;
    float _816 = 8.0;
    float _818 = 24.0;
    vec2 _827 = _655._m16.xy * _676._m6.xy;
    vec3 _820;
    _820 = vec3(_827.x, _827.y, _820.z);
    _820.y = 1.0 - _820.y;
    vec2 _840 = floor(_820.xy * vec2(_814, _816));
    _820 = vec3(_840.x, _840.y, _820.z);
    float _845 = _655._m16.z;
    vec4 _848 = _676._m7;
    float _851 = 1.0;
    bool _852 = false;
    float _843 = _130(_845, _848, _851, _852);
    float _854 = log2(max(1.0, _843 / _676._m8.z)) * _676._m8.w;
    _820.z = min(_818 - 1.0, floor(_854));
    uint _870 = uint((_820.x + (_820.y * _814)) + ((_820.z * _814) * _816));
    bool _886 = true;
    _886 = gl_FrontFacing;
    vec3 _891 = _655._m6;
    bool _894 = _886;
    _655._m7 = _135(_891, _894);
    vec3 _898 = _655._m7;
    mat3 _901 = _655._m17;
    _655._m6 = _142(_898, _901);
    uint _906 = 0u;
    uint _907 = 0u;
    uint _908 = 0u;
    uint _909 = 0u;
    uint _910 = 0u;
    uint _911 = 0u;
    int _913 = 256;
    _915 _917;
    _917._m0 = _922._m0[_870]._m0;
    _917._m1 = _922._m0[_870]._m1;
    int _931 = _917._m0 & (~(_917._m0 >> 31));
    int _940 = _917._m1 & (~(_917._m1 >> 31));
    _906 = uint((_931 >> 16) * _913);
    _907 = _906 + uint(_940 & 255);
    _908 = _906;
    _909 = _908 + uint((_940 >> 8) & 255);
    _910 = _906;
    _911 = _910 + uint((_940 >> 16) & 255);
    vec3 _973 = vec3(0.0);
    vec3 _974 = vec3(_655._m34.x, _655._m34.y, _655._m34.z);
    vec3 _982 = vec3(_655._m34.w, _655._m35.x, _655._m35.y);
    vec3 _990 = vec3(_655._m35.z, _655._m35.w, _655._m36.x);
    vec3 _998 = vec3(_655._m36.y, _655._m36.z, _655._m36.w);
    vec3 _1006 = ((_974 - (_982 * _655._m6.y)) + (_990 * _655._m6.z)) - (_998 * _655._m6.x);
    float _1029 = _808._m9.x * _676._m9.x;
    _973 += max(_1006 * _14(_1029), vec3(0.0));
    float _1040;
    if (dot(_655._m10, vec3(1.0)) > 0.0)
    {
        _1040 = -_655._m3;
    }
    else
    {
        _1040 = _655._m3;
    }
    _655._m3 = _1040;
    _655._m18 = _973;
    _655._m19 = _973;
    float _1057 = 1.0;
    uint _1058 = _910;
    _1094 _1096;
    while (_1058 < _911)
    {
        uint _1068 = _1072._m0[_1058];
        uint _1077 = (_1068 >> uint(24)) & 4095u;
        uint _1082 = _1077;
        if (_1082 >= _1077)
        {
            _1058++;
        }
        int _1091 = 4;
        int _1092 = 4;
        int _1093 = 3;
        _1096._m0 = _1101._m0[(uint(_1091) * _1082) + 0u].xyz;
        float _1116 = _1101._m0[(uint(_1091) * _1082) + 0u].w;
        _1096._m1 = _32(_1116);
        _1096._m2 = _1101._m0[(uint(_1091) * _1082) + 1u];
        _1096._m3 = _1101._m0[(uint(_1091) * _1082) + 2u];
        _1096._m4 = _1140._m0[(uint(_1092) * _1082) + 0u];
        _1096._m5 = _1140._m0[(uint(_1092) * _1082) + 1u];
        _1096._m6 = _1140._m0[(uint(_1092) * _1082) + 2u];
        float _1170 = _1101._m0[(uint(_1091) * _1082) + 3u].x;
        _1096._m7.x = _32(_1170);
        float _1180 = _1101._m0[(uint(_1091) * _1082) + 3u].y;
        _1096._m7.y = _32(_1180);
        float _1190 = _1101._m0[(uint(_1091) * _1082) + 3u].z;
        _1096._m7.z = _32(_1190);
        float _1200 = _1101._m0[(uint(_1091) * _1082) + 3u].w;
        _1096._m7.w = _32(_1200);
        _1096._m8 = _1209._m0[(uint(_1093) * _1082) + 0u];
        _1096._m9 = _1209._m0[(uint(_1093) * _1082) + 1u];
        _1096._m10 = _1209._m0[(uint(_1093) * _1082) + 2u];
        float _1239 = _1140._m0[(uint(_1092) * _1082) + 3u].x;
        _1096._m11 = _32(_1239);
        float _1250 = _1140._m0[(uint(_1092) * _1082) + 3u].y;
        _1096._m12 = _32(_1250);
        _1096._m13 = _1140._m0[(uint(_1092) * _1082) + 3u].z;
        float _1268 = _1140._m0[(uint(_1092) * _1082) + 3u].w;
        _1096._m14 = _32(_1268);
        vec3 _1273 = vec3((_655._m14.x * _1096._m4.x) + ((_655._m14.y * _1096._m4.y) + ((_655._m14.z * _1096._m4.z) + _1096._m4.w)), (_655._m14.x * _1096._m5.x) + ((_655._m14.y * _1096._m5.y) + ((_655._m14.z * _1096._m5.z) + _1096._m5.w)), (_655._m14.x * _1096._m6.x) + ((_655._m14.y * _1096._m6.y) + ((_655._m14.z * _1096._m6.z) + _1096._m6.w)));
        vec2 _1340 = _1273.xy / vec2(_1273.z);
        _1273 = vec3(_1340.x, _1340.y, _1273.z);
        _1273.z = (_655._m14.x * _1096._m3.x) + ((_655._m14.y * _1096._m3.y) + ((_655._m14.z * _1096._m3.z) + _1096._m3.w));
        float _1364 = 0.0039215688593685626983642578125;
        float _1366 = _1273.x;
        float _1369 = _1273.y;
        float _1372 = _1273.z;
        bool _1377 = _43(_1366, _1369, _1372) < _1364;
        bool _1394;
        if (!_1377)
        {
            float _1381 = _1273.x;
            float _1384 = _1273.y;
            float _1387 = _1273.z;
            _1394 = _38(_1381, _1384, _1387) >= (1.0 - _1364);
        }
        else
        {
            _1394 = _1377;
        }
        if (_1394)
        {
            continue;
        }
        uint _1398 = _1096._m1;
        uint _1402 = _1096._m12;
        vec3 _1401 = _110(_1402);
        float _1406 = _1096._m13;
        vec3 _1409 = _1096._m0;
        uint _1413 = _1398;
        float _1412 = _84(_1413).y;
        vec3 _1417 = (_1273 * 2.0) - vec3(1.0);
        vec3 _1421 = _1417 * sqrt(((vec3(1.0) - ((_1417.yzx * _1417.yzx) * 0.5)) - ((_1417.zxy * _1417.zxy) * 0.5)) + ((((_1417.yzx * _1417.yzx) * _1417.zxy) * _1417.zxy) / vec3(3.0)));
        float _1465 = 1.0 - ((length(_1421) - _1412) / ((1.0 - _1412) + 9.9999999747524270787835121154785e-07));
        float _1454 = _14(_1465);
        _1454 *= _1454;
        _1454 *= (_1096._m8.w * _1057);
        _1057 *= (1.0 - _1454);
        if (_1454 <= (_1364 * 4.0))
        {
            continue;
        }
        vec3 _1487 = _1401;
        uint _1490 = _1398;
        float _1489 = _87(_1490).z;
        vec3 _1494 = vec3(0.0);
        vec3 _1495 = vec3(0.0);
        vec3 _1496 = _655._m6;
        _1496.x = dot(_1096._m2.xy, _655._m6.xy);
        _1496.y = dot(_1096._m2.zw, _655._m6.xy);
        vec3 _1515 = reflect(-_655._m13, _655._m6);
        vec3 _1522 = (_1096._m9.xyz - _655._m14) / _1515;
        vec3 _1531 = (_1096._m8.xyz - _655._m14) / _1515;
        vec3 _1540 = max(_1522, _1531);
        float _1545 = _1540.x;
        float _1548 = _1540.y;
        float _1551 = _1540.z;
        float _1544 = _43(_1545, _1548, _1551);
        vec3 _1555 = _655._m14 + (_1515 * _1544);
        vec3 _1562 = normalize(_1555 - _1409);
        vec3 _1567 = _1562;
        _1567.x = dot(_1096._m2.xy, _1562.xy);
        _1567.y = dot(_1096._m2.zw, _1562.xy);
        float _1589 = dot(_655._m13, _655._m6);
        float _1583 = _14(_1589);
        float _1591 = 0.0;
        float _1592 = 6.0;
        float _1594 = max(_1591, _1592 - (_1592 * abs(_655._m3)));
        _1495 = textureLod(_1607, vec4(_1567, _1489), _1594).xyz * _1406;
        float _1624 = _1583;
        float _1626 = abs(_655._m3);
        vec3 _1627 = _655._m2;
        vec3 _1620 = _121(_1624, _1626, _1627);
        _1495 *= _1620;
        float _1638 = _1454;
        _655._m20 += ((_1495 * _1487) * _14(_1638));
        if (_1057 <= (_1364 * 4.0))
        {
            break;
        }
    }
    uint _1653 = _906;
    _1094 _1682;
    vec3 _1967;
    float _2044;
    float _2062;
    _2433 _2435;
    uint _2556;
    _2433 _2580;
    while (_1653 < _907)
    {
        uint _1663 = _1072._m0[_1653];
        uint _1667 = _1663 & 4095u;
        uint _1670 = _1667;
        if (_1670 >= _1667)
        {
            _1653++;
        }
        int _1679 = 4;
        int _1680 = 4;
        int _1681 = 3;
        _1682._m0 = _1101._m0[(uint(_1679) * _1670) + 0u].xyz;
        float _1697 = _1101._m0[(uint(_1679) * _1670) + 0u].w;
        _1682._m1 = _32(_1697);
        _1682._m2 = _1101._m0[(uint(_1679) * _1670) + 1u];
        _1682._m3 = _1101._m0[(uint(_1679) * _1670) + 2u];
        _1682._m4 = _1140._m0[(uint(_1680) * _1670) + 0u];
        _1682._m5 = _1140._m0[(uint(_1680) * _1670) + 1u];
        _1682._m6 = _1140._m0[(uint(_1680) * _1670) + 2u];
        float _1747 = _1101._m0[(uint(_1679) * _1670) + 3u].x;
        _1682._m7.x = _32(_1747);
        float _1757 = _1101._m0[(uint(_1679) * _1670) + 3u].y;
        _1682._m7.y = _32(_1757);
        float _1767 = _1101._m0[(uint(_1679) * _1670) + 3u].z;
        _1682._m7.z = _32(_1767);
        float _1777 = _1101._m0[(uint(_1679) * _1670) + 3u].w;
        _1682._m7.w = _32(_1777);
        _1682._m8 = _1209._m0[(uint(_1681) * _1670) + 0u];
        _1682._m9 = _1209._m0[(uint(_1681) * _1670) + 1u];
        _1682._m10 = _1209._m0[(uint(_1681) * _1670) + 2u];
        float _1811 = _1140._m0[(uint(_1680) * _1670) + 3u].x;
        _1682._m11 = _32(_1811);
        float _1821 = _1140._m0[(uint(_1680) * _1670) + 3u].y;
        _1682._m12 = _32(_1821);
        _1682._m13 = _1140._m0[(uint(_1680) * _1670) + 3u].z;
        float _1839 = _1140._m0[(uint(_1680) * _1670) + 3u].w;
        _1682._m14 = _32(_1839);
        float _1844 = 0.0039215688593685626983642578125;
        vec4 _1845 = vec4(_655._m14, 1.0);
        float _1852 = 1.0 / dot(_1845, _1682._m6);
        vec3 _1858 = vec3(dot(_1845, _1682._m4) * _1852, dot(_1845, _1682._m5) * _1852, dot(_1845, _1682._m3));
        uint _1876 = _1682._m1;
        uint _1879 = _805;
        _1879 |= 64u;
        float _1884 = _1858.x;
        float _1887 = _1858.y;
        float _1890 = _1858.z;
        bool _1895 = _43(_1884, _1887, _1890) <= _1844;
        bool _1912;
        if (!_1895)
        {
            float _1899 = _1858.x;
            float _1902 = _1858.y;
            float _1905 = _1858.z;
            _1912 = _38(_1899, _1902, _1905) >= (1.0 - _1844);
        }
        else
        {
            _1912 = _1895;
        }
        bool _1920;
        if (!_1912)
        {
            _1920 = (_1876 & _1879) != 0u;
        }
        else
        {
            _1920 = _1912;
        }
        if (_1920)
        {
            continue;
        }
        if ((_1876 & 3u) == 2u)
        {
            vec2 _1939 = fract((_1858.xy * _676._m10.xy) + _676._m10.zw);
            _1858 = vec3(_1939.x, _1939.y, _1858.z);
        }
        vec3 _1942 = _1682._m0;
        float _1945 = 1.0;
        float _1946 = 1.0;
        vec3 _1947 = vec3(0.0, 0.0, 1.0);
        vec3 _1948 = vec3(0.0, 0.0, 1.0);
        uint _1949 = _1682._m1;
        vec3 _1952 = (_1858 * 2.0) - vec3(1.0);
        vec2 _1957 = _1858.xy;
        vec3 _1960 = _1682._m10.xyz;
        if ((_1949 & 3u) == 2u)
        {
            _1967 = _1960;
        }
        else
        {
            _1967 = normalize(_1942 - _655._m14);
        }
        _1947 = _1967;
        _1947 = _1947;
        float _1984 = dot(_655._m6, _1947);
        float _1979 = _14(_1984);
        uvec2 _1987 = _1682._m7.zw;
        vec4 _1986 = _97(_1987);
        float _1993 = TEXTURE_LOD(_1994, vec4((_1957 * _1986.xy) + _1986.zw, 0.0, 0.0).xy, vec4((_1957 * _1986.xy) + _1986.zw, 0.0, 0.0).w).x;
        float _2020 = _1993 * _1993;
        uint _2024 = _1949 & 3u;
        bool _2029 = _2024 == 1u;
        bool _2041;
        if (!_2029)
        {
            bool _2034 = _2024 == 0u;
            bool _2040;
            if (_2034)
            {
                _2040 = _1682._m8.z != 0.0;
            }
            else
            {
                _2040 = _2034;
            }
            _2041 = _2040;
        }
        else
        {
            _2041 = _2029;
        }
        bool _2027 = _2041;
        if (_2027)
        {
            float _2047 = _1682._m8.w;
            _2044 = _14(_2047);
        }
        else
        {
            _2044 = 0.5;
        }
        float _2042 = _2044;
        bool _2055 = _2024 == 0u;
        bool _2061;
        if (_2055)
        {
            _2061 = _1682._m8.z != 0.0;
        }
        else
        {
            _2061 = _2055;
        }
        if (_2061)
        {
            float _2070 = sqrt(dot(_1952, _1952));
            _2062 = min(0.9921875, _14(_2070));
        }
        else
        {
            _2062 = _1858.z;
        }
        float _2053 = _2062;
        uvec2 _2078 = _1682._m7.xy;
        vec4 _2077 = _97(_2078);
        vec2 _2083 = vec2(_2053, _2042);
        float _2087 = TEXTURE_LOD(_1994, vec4((_2083 * _2077.xy) + _2077.zw, 0.0, 0.0).xy, vec4((_2083 * _2077.xy) + _2077.zw, 0.0, 0.0).w).x;
        _2087 *= _2087;
        _1945 = _2087 * _2020;
        if ((_1949 & 48u) != 0u)
        {
            vec4 _2125 = _1682._m10;
            vec4 _2128 = _1682._m8;
            vec4 _2131 = _1682._m9;
            float _2134 = dot(_655._m14, _2125.xyz) + _2125.w;
            if (_2134 < 0.0)
            {
                continue;
            }
            float _2148 = length(_2125.xyz);
            float _2155 = _2134 * 50.0;
            float _2152 = _14(_2155);
            _1945 *= (_2152 * _2152);
            _2134 /= _2148;
            _2125 /= vec4(_2148);
            vec3 _2169 = reflect(-_655._m13, _655._m6);
            if (dot(_2169, _2125.xyz) > 0.0)
            {
                _2169 = reflect(_2169, _2125.xyz);
            }
            float _2187 = dot(_2169, _2125.xyz);
            float _2192 = _2134 / _2187;
            vec3 _2196 = _655._m14 - (_2169 * _2192);
            vec3 _2203 = _2196 - _1942;
            float _2207 = dot(_2203, _2128.xyz) / _2128.w;
            float _2215 = dot(_2203, _2131.xyz) / _2131.w;
            if ((_1949 & 48u) == 32u)
            {
                vec2 _2229 = vec2(_2207, _2215);
                float _2233 = 1.0 / max(1.0, length(vec2(_2207, _2215)));
                _2207 *= (_2233 * _2128.w);
                _2215 *= (_2233 * _2131.w);
            }
            else
            {
                float _2255 = abs(_2207);
                float _2257 = _2207;
                _2207 = (_14(_2255) * _76(_2257)) * _2128.w;
                float _2266 = abs(_2215);
                float _2268 = _2215;
                _2215 = (_14(_2266) * _76(_2268)) * _2131.w;
            }
            vec3 _2275 = (_2128.xyz * _2207) + (_2131.xyz * _2215);
            _1942 += _2275;
            _1947 = normalize(_1942 - _655._m14);
            _1947 = _1947;
        }
        else
        {
            uint _2295 = (_1682._m14 >> uint(16)) & 255u;
            if (_2295 == 0u)
            {
                vec4 _2304 = _1682._m9;
                if (dot(_2304.xyz, _655._m14) < (_2304.w - _1844))
                {
                    continue;
                }
            }
            else
            {
                if (_2295 == 1u)
                {
                    vec3 _2325 = _1682._m9.xyz;
                    float _2330 = _1682._m9.w;
                    uint _2334 = _32(_2330);
                    vec3 _2329 = (((_91(_2334) * 2.0) - vec3(1.0)) * _2325) + _1942;
                    vec3 _2343 = abs((_655._m14 - _2329) / _2325);
                    float _2351 = _2343.x;
                    float _2354 = _2343.y;
                    float _2357 = _2343.z;
                    if (_38(_2351, _2354, _2357) > 1.0)
                    {
                        continue;
                    }
                }
            }
        }
        if (_1945 <= (_1844 / 256.0))
        {
            continue;
        }
        float _2373 = 1.0;
        if ((_1876 & 4u) != 0u)
        {
            float _2380 = float(_1682._m14 & 255u) / 255.0;
            float _2386 = 0.00200000009499490261077880859375;
            vec3 _2388 = _655._m14 + (_655._m6 * _2386);
            uint _2396 = 0u;
            if ((_1876 & 3u) == 0u)
            {
                vec3 _2402 = _2388 - _1682._m2.xyz;
                float _2408 = _2402.x;
                float _2411 = _2402.y;
                float _2414 = _2402.z;
                _2396 = _49(_2408, _2411, _2414);
            }
            else
            {
                if ((_1876 & 3u) == 2u)
                {
                    float _2424 = 0.0;
                    for (; _2396 < 3u; _2396++)
                    {
                        int _2432 = 5;
                        _2435._m0 = _2439._m0[(uint(_2432) * ((_1876 >> uint(22)) + _2396)) + 0u];
                        _2435._m1 = _2439._m0[(uint(_2432) * ((_1876 >> uint(22)) + _2396)) + 1u];
                        _2435._m2 = _2439._m0[(uint(_2432) * ((_1876 >> uint(22)) + _2396)) + 2u];
                        _2435._m3 = _2439._m0[(uint(_2432) * ((_1876 >> uint(22)) + _2396)) + 3u];
                        _2435._m4 = _2439._m0[(uint(_2432) * ((_1876 >> uint(22)) + _2396)) + 4u];
                        vec2 _2496 = vec2(dot(_2388, _2435._m0.xyz) + _2435._m0.w, dot(_2388, _2435._m1.xyz) + _2435._m1.w);
                        _2496 = abs((_2496 * 2.0) - vec2(1.0));
                        bool _2521 = _2496.x < 1.0;
                        bool _2527;
                        if (_2521)
                        {
                            _2527 = _2496.y < 1.0;
                        }
                        else
                        {
                            _2527 = _2521;
                        }
                        if (_2527)
                        {
                            _2424 = (1.0 - max(_2496.x, _2496.y)) * _676._m11.w;
                            break;
                        }
                    }
                    _2396 = min(2u, _2396);
                    uint _2544 = uint(_655._m16.x) ^ (uint(_655._m16.y) << uint(1));
                    if (_676._m12.w > 0.0)
                    {
                        _2556 = uint(_676._m13.x);
                    }
                    else
                    {
                        _2556 = 0u;
                    }
                    _2544 ^= _2556;
                    _2396 += uint(int(((float(_2544 & 3u) * 0.25) + 0.125) > _2424));
                }
            }
            int _2579 = 5;
            _2580._m0 = _2439._m0[(uint(_2579) * ((_1876 >> uint(22)) + _2396)) + 0u];
            _2580._m1 = _2439._m0[(uint(_2579) * ((_1876 >> uint(22)) + _2396)) + 1u];
            _2580._m2 = _2439._m0[(uint(_2579) * ((_1876 >> uint(22)) + _2396)) + 2u];
            _2580._m3 = _2439._m0[(uint(_2579) * ((_1876 >> uint(22)) + _2396)) + 3u];
            _2580._m4 = _2439._m0[(uint(_2579) * ((_1876 >> uint(22)) + _2396)) + 4u];
            vec4 _2636 = vec4((_2388.x * _2580._m0.x) + ((_2388.y * _2580._m0.y) + ((_2388.z * _2580._m0.z) + _2580._m0.w)), (_2388.x * _2580._m1.x) + ((_2388.y * _2580._m1.y) + ((_2388.z * _2580._m1.z) + _2580._m1.w)), (_2388.x * _2580._m2.x) + ((_2388.y * _2580._m2.y) + ((_2388.z * _2580._m2.z) + _2580._m2.w)), (_2388.x * _2580._m3.x) + ((_2388.y * _2580._m3.y) + ((_2388.z * _2580._m3.z) + _2580._m3.w)));
            vec3 _2723 = _2636.xyz / vec3(_2636.w);
            _2636 = vec4(_2723.x, _2723.y, _2723.z, _2636.w);
            bool _2731 = min(_2636.x, _2636.y) > 0.0;
            bool _2740;
            if (_2731)
            {
                _2740 = max(_2636.x, _2636.y) < 1.0;
            }
            else
            {
                _2740 = _2731;
            }
            if (_2740)
            {
                vec2 _2752 = (_2636.xy * _2580._m4.xy) + _2580._m4.zw;
                _2636 = vec4(_2752.x, _2752.y, _2636.z, _2636.w);
                if (false)
                {
                    _2373 = textureLod(_2760, vec3(_2636.xyz.xy, _2636.xyz.z), 0.0);
                }
                else
                {
                    vec2 _2767 = (_2636.xy * _676._m14.xy) + vec2(0.5);
                    vec2 _2776 = floor(_2767);
                    vec2 _2779 = _2767 - _2776;
                    _2776 -= vec2(0.5);
                    vec2 _2786 = vec2(4.0) - (_2779 * 3.0);
                    vec2 _2791 = vec2(7.0);
                    vec2 _2794 = vec2(1.0) + (_2779 * 3.0);
                    vec2 _2799 = (_2776 + (((vec2(3.0) - (_2779 * 2.0)) / _2786) - vec2(2.0))) * _676._m14.zw;
                    vec2 _2814 = (_2776 + ((vec2(3.0) + _2779) / _2791)) * _676._m14.zw;
                    vec2 _2826 = (_2776 + ((_2779 / _2794) + vec2(2.0))) * _676._m14.zw;
                    vec3 _2850 = vec3(_2799.x, _2799.y, _2636.z);
                    _2373 = (_2786.x * _2786.y) * textureLod(_2760, vec3(_2850.xy, _2850.z), 0.0);
                    vec3 _2866 = vec3(_2814.x, _2799.y, _2636.z);
                    _2373 += ((_2791.x * _2786.y) * textureLod(_2760, vec3(_2866.xy, _2866.z), 0.0));
                    vec3 _2884 = vec3(_2826.x, _2799.y, _2636.z);
                    _2373 += ((_2794.x * _2786.y) * textureLod(_2760, vec3(_2884.xy, _2884.z), 0.0));
                    vec3 _2902 = vec3(_2799.x, _2814.y, _2636.z);
                    _2373 += ((_2786.x * _2791.y) * textureLod(_2760, vec3(_2902.xy, _2902.z), 0.0));
                    vec3 _2920 = vec3(_2814.x, _2814.y, _2636.z);
                    _2373 += ((_2791.x * _2791.y) * textureLod(_2760, vec3(_2920.xy, _2920.z), 0.0));
                    vec3 _2938 = vec3(_2826.x, _2814.y, _2636.z);
                    _2373 += ((_2794.x * _2791.y) * textureLod(_2760, vec3(_2938.xy, _2938.z), 0.0));
                    vec3 _2956 = vec3(_2799.x, _2826.y, _2636.z);
                    _2373 += ((_2786.x * _2794.y) * textureLod(_2760, vec3(_2956.xy, _2956.z), 0.0));
                    vec3 _2974 = vec3(_2814.x, _2826.y, _2636.z);
                    _2373 += ((_2791.x * _2794.y) * textureLod(_2760, vec3(_2974.xy, _2974.z), 0.0));
                    vec3 _2992 = vec3(_2826.x, _2826.y, _2636.z);
                    _2373 += ((_2794.x * _2794.y) * textureLod(_2760, vec3(_2992.xy, _2992.z), 0.0));
                    _2373 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _2373 = float((_1876 & 3u) == 2u);
            }
            float _3006 = float((_1876 >> uint(16)) & 63u) / 63.0;
            float _3020 = ((_2373 * _3006) + 1.0) - _3006;
            _2373 = _14(_3020);
        }
        uint _3023 = _1682._m12;
        vec3 _3022 = (_110(_3023) * _2373) * _1945;
        _1946 *= _1682._m13;
        vec3 _3035 = _3022;
        vec3 _3037 = vec3(_655._m17[0].x, _655._m17[1].x, _655._m17[2].x);
        vec3 _3045 = vec3(_655._m17[0].y, _655._m17[1].y, _655._m17[2].y);
        vec3 _3053 = _655._m13;
        vec3 _3056 = _655._m6;
        vec3 _3059 = normalize(_1942 - _655._m14);
        float _3065 = 0.5;
        float _3066 = dot(_3056, _3059);
        float _3077 = 1.0 + _3065;
        float _3080 = (abs(_3066) + _3065) / _65(_3077);
        float _3070 = _14(_3080);
        vec3 _3082 = normalize(_3053 + _3059);
        float _3087 = dot(_3056, _3082);
        vec3 _3091 = vec3(0.0);
        float _3092 = 1.0 - _759._m4.z;
        float _3096 = _3092 * _3092;
        float _3100 = 1.0;
        float _3101 = _3100 * _3100;
        float _3105 = dot(normalize(_3037 + ((_3056 * _759._m4.x) * _650)), _3082);
        float _3117 = dot(normalize(_3045 + ((_3056 * _759._m4.x) * _650)), _3082);
        float _3129 = (((_3105 * _3105) / _3101) + ((_3117 * _3117) / _3096)) + (_3087 * _3087);
        _3091 = vec3(1.0 / (_3129 * _3129)) / vec3((_3101 * _3096) + 9.9999999392252902907785028219223e-09);
        float _3161 = dot(_3056, _3053);
        float _3157 = (_14(_3161) * (1.0 - _3092)) + _3092;
        float _3172 = dot(_3056, _3059);
        float _3168 = (_14(_3172) * (1.0 - _3092)) + _3092;
        _3091 /= vec3(((4.0 * _3157) * _3168) + 9.9999999392252902907785028219223e-09);
        vec3 _3187 = vec3(0.0);
        float _3188 = 1.0 - _759._m4.w;
        float _3192 = _3188 * _3188;
        float _3196 = 1.0;
        float _3197 = _3196 * _3196;
        float _3201 = dot(normalize(_3037 + ((_3056 * _759._m4.y) * _650)), _3082);
        float _3213 = dot(normalize(_3045 + ((_3056 * _759._m4.y) * _650)), _3082);
        float _3225 = (((_3201 * _3201) / _3197) + ((_3213 * _3213) / _3192)) + (_3087 * _3087);
        _3187 = vec3(1.0 / (_3225 * _3225)) / vec3((_3197 * _3192) + 9.9999999392252902907785028219223e-09);
        float _3256 = dot(_3056, _3053);
        float _3252 = (_14(_3256) * (1.0 - _3188)) + _3188;
        float _3267 = dot(_3056, _3059);
        float _3263 = (_14(_3267) * (1.0 - _3188)) + _3188;
        _3187 /= vec3(((4.0 * _3252) * _3263) + 9.9999999392252902907785028219223e-09);
        vec3 _3289 = _655._m2;
        float _3292 = dot(_3059, _3082);
        vec3 _3282 = (_3091 + _3187) * _115(_3289, _3292);
        float _3301 = _3066;
        vec3 _3295 = ((_3282 * _1946) * _3035) * _14(_3301);
        float _3313 = -_3066;
        vec3 _3305 = ((_3282 * _1946) * _3035) * _14(_3313);
        _655._m20 += _3295;
        _655._m19 += ((_3035 * _3070) + _3305);
    }
    _655._m19 = _655._m19;
    _655._m20 += _655._m10;
    _655._m19 *= _655._m0;
    _655._m21 = _655._m19 + _655._m20;
    vec2 _3351 = gl_FragCoord.xy * _676._m6.xy;
    _3351.y = 1.0 - _3351.y;
    vec4 _3362 = vec4((_3351.x * 2.0) - 1.0, (_3351.y * 2.0) - 1.0, gl_FragCoord.z, 1.0);
    vec3 _3375;
    _3375.x = dot(_3362, _676._m15);
    _3375.y = dot(_3362, _676._m16);
    _3375.z = dot(_3362, _676._m17);
    _3375 /= vec3(dot(_3362, _676._m18));
    float _3398 = SAMPLE_TEXTURE(_3399, _3401.xy * vec2(_808._m10.w)).y;
    vec4 _3418 = vec4(_808._m6.xyz, 1.0);
    vec4 _3419 = _808._m1;
    vec3 _3410;
    _3410.x = _27(_3418, _3419);
    vec4 _3431 = vec4(_808._m6.xyz, 1.0);
    vec4 _3432 = _808._m2;
    _3410.y = _27(_3431, _3432);
    vec4 _3444 = vec4(_808._m6.xyz, 1.0);
    vec4 _3445 = _808._m3;
    _3410.z = _27(_3444, _3445);
    vec3 _3450 = _3410 - _3375;
    float _3454 = (_3398 * _759._m5.x) + (1.0 - _759._m5.x);
    float _3463 = length(_3450) * _3454;
    vec2 _3468 = vec2(6.666666507720947265625, 10.0);
    float _3472 = _3463 - _808._m7.w;
    float _3482 = _3472 * _3468.x;
    float _3477 = _14(_3482);
    float _3489 = _3472 * _3468.y;
    float _3484 = _14(_3489);
    float _3499 = (1.0 - _3484) * _3398;
    vec3 _3491 = _808._m10.xyz * _14(_3499);
    float _3502 = _3477;
    float _3509 = ceil(_3502 - 0.001000000047497451305389404296875);
    float _3504 = _14(_3509);
    float _3514 = _3504 - 9.9999997473787516355514526367188e-05;
    _10(_3514);
    _655._m19 += _3491;
    vec3 _3527 = _655._m19 + _655._m20;
    _3522 = vec4(_3527.x, _3527.y, _3527.z, _3522.w);
    vec3 _3531 = _655._m6;
    bool _3534 = false;
    vec2 _3535 = _151(_3531, _3534);
    _3530 = vec4(_3535.x, _3535.y, _3530.z, _3530.w);
    float _3539 = _655._m2.x;
    float _3543 = _655._m2.y;
    float _3547 = _655._m2.z;
    float _3551 = _655._m3;
    _3538 = vec4(_79(_3539), _79(_3543), _79(_3547), _154(_3551));
    vec3 _3561 = _3522.xyz + _808._m11.xyz;
    _3522 = vec4(_3561.x, _3561.y, _3561.z, _3522.w);
    float _3570 = SAMPLE_TEXTURE(_3565, _667.xy).x;
    float _3573 = _759._m3.z;
    float _3578 = mix(1.0, _65(_3570), _14(_3573));
    float _3564 = _14(_3578);
    vec3 _3584 = _3522.xyz * vec3(_3564);
    _3522 = vec4(_3584.x, _3584.y, _3584.z, _3522.w);
}

